﻿If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_UserPhoto' ))
    If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_UserPhoto' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'filename' )
	Alter Table oktell_settings.dbo.A_UserPhoto
	Add [Filename] nvarchar(200)
GO


If exists ( select * From sysobjects where id = object_id ( 'dbo.A_UserPhoto' ) and objectproperty ( id, N'isview' ) = 1 )
  	Drop view dbo.A_UserPhoto
GO


Create View dbo.A_UserPhoto
As
  	Select *
  	From oktell_settings.dbo.A_UserPhoto
GO


if exists ( Select * FROM sysobjects where id= object_id ( 'dbo.A_Admin_UserPhoto_Save' ))
	Drop procedure dbo.A_Admin_UserPhoto_Save
GO

Create procedure dbo.A_Admin_UserPhoto_Save
	@user uniqueidentifier,
	@photo image = null,
	@filename nvarchar(200) = null,
	@modifieduser uniqueidentifier,
	@dtnow datetime = null
as
begin
	if ( @dtnow is null )
	   Set @dtnow = GetDate()

	Update A_UserPhoto
	Set photo = @photo,
		[filename] = @filename,
		modifieduser = @modifieduser,
		modifieddt = @dtnow
	Where id = @user

	if ( @@rowcount = 0 ) 
	   Insert into A_UserPhoto ( [id], photo, [filename], modifieduser, modifieddt )
	   Values ( @user, @photo, @filename, @modifieduser, @dtnow )	
end
GO


if exists ( Select * FROM sysobjects where id= object_id ( 'dbo.A_Admin_UserPhoto_Get' ))
	Drop procedure dbo.A_Admin_UserPhoto_Get
GO

Create procedure dbo.A_Admin_UserPhoto_Get
	@user uniqueidentifier
as
begin
	Select up.id, 
		DataLength(up.photo) as Length, up.photo, 
		up.modifieddt, 
		up.modifieduser, IsNull ( u.Name, '' ) as modifiedusername,
		up.[filename]
	From A_UserPhoto up
		Left join A_Users u on u.id = up.modifieduser
	Where up.id = @user
end
GO


if exists ( Select * FROM sysobjects where id= object_id ( 'dbo.A_Admin_UserPhoto_GetAll' ))
	Drop procedure dbo.A_Admin_UserPhoto_GetAll
GO

Create procedure dbo.A_Admin_UserPhoto_GetAll
as
begin
	Select up.id,
		DataLength(up.photo) as Length, up.photo, 
		up.modifieddt, 
		up.modifieduser, IsNull ( u.Name, '' ) as modifiedusername,
		up.[filename]
	From A_UserPhoto up
		Left join A_Users u on u.id = up.modifieduser
end
GO