﻿if exists ( Select * FROM sysobjects where id= object_id ( 'dbo.A_CallCenter_Temp_UpdateOperatorStates' ))
	Drop procedure dbo.A_CallCenter_Temp_UpdateOperatorStates
GO


Create Procedure [dbo].[A_CallCenter_Temp_UpdateOperatorStates]
	@dtnow datetime = null
as 
begin

set dateformat dmy

if ( @dtnow is null )	
	set @dtnow = DateAdd ( ss, -30, GetDate() )

if not exists ( Select * FROM master..sysdatabases where name like 'oktell_cc_temp' )
	return

--Declare @fulllogdt DateTime
--Declare @logdt DateTime
--Declare @operlogdt DateTime
Declare @sqltext nvarchar ( 4000 )

Declare @idempty uniqueidentifier
Set @idempty = '00000000-0000-0000-0000-000000000000'

--print '   ## start creating temp tables ' + Cast ( DatePart ( hh, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( mm, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )	
--print 's 00  ' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )	
--print '--------------------------------------start-- ms:  ' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )
--Set @logdt = GetDate ( )
--Set @fulllogdt = GetDate ( )

-- Всех операторов в таблицу
Declare @settable table ( Id uniqueidentifier, Name nvarchar ( 500 ) collate database_default)
Insert into @settable
	Select Id, Name From A_Users u 
		Inner join A_UserParams up on u.Id = up.IdUser
	Where IsOperator = 1

-- N минут назад
Declare @dt10m DateTime
Set @dt10m = DateAdd ( mi, -20, @dtnow )

-- формируем общую выборку из статистики коммутаций
Declare @dtsall DateTime
Select @dtsall = Min ( LastDT ) 
From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] oi
	Inner join @settable up on oi.Id = up.Id

-- Если нет распоследнего - расчитываем за 10 дней.
if ( @dtsall is null )
	Set @dtsall = DateAdd ( d, -10, @dtnow )

-- Новое (06.2010)
-- Если распоследний менее чем 10 минут до текущего момента - считать будем 10 минут.
if ( @dtsall > @dt10m )
	Set @dtsall = @dt10m

-- Debug
--Select 'dtsAll', @dtsall

--set @dtsall = '6.10.2007 14:20'
--print @dtsall
--print 's 01  ' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )	

--Declare @sc table ( FromCC bit, IsBetweenUsers bit, TimeStart DateTime, TimeAnswer DateTime, TimeStop DateTime, AUserId uniqueidentifier, BUserId uniqueidentifier )

/*
Insert Into @sc
	Select FromCC, IsBetweenUsers, TimeStart, TimeAnswer, TimeStop, AUserId, BUserId
	From A_Stat_Connections_1x1 sc With ( TabLock )
	Where TimeStart > @dtsall Or TimeStop > @dtsall Or TimeStop is null

print 's 02_1  ' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )	
*/

	if exists ( Select * FROM tempdb..sysobjects Where Id = object_id ( 'tempdb..#sc' ) )
		Drop Table #sc
	Create table #sc ( FromCC bit, IsBetweenUsers bit, TimeStart DateTime, TimeAnswer DateTime, TimeStop DateTime, AUserId uniqueidentifier, BUserId uniqueidentifier )

	set @sqltext = 'Select FromCC, IsBetweenUsers, TimeStart, TimeAnswer, TimeStop, AUserId, BUserId 
		From A_Stat_Connections_1x1 sc 
		Where ( TimeStart > @dtt1 Or TimeStop > @dtt1 Or TimeStop is null ) And ( TimeStart < @dtnow )'
	Insert Into #sc
		exec sp_executesql @sqltext, N'@dtt1 datetime, @dtnow datetime', @dtsall, @dtnow
	--Insert into @sc
	--	Select * FROM #sc

	--drop table #sc


--print 's 02_2  ' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )	

--Declare @ush table ( OperatorId uniqueidentifier, State int, TimeEnter DateTime, TimeLeave DateTime, Info nvarchar ( 100 ) collate database_default, ICode int)

/*
Insert into @ush
	Select OperatorId, State, TimeEnter, TimeLeave, case when selfinfo = 1 then Info else '' end
	From A_CallCenter_UserStateHistory with ( TabLock )
	Where ( TimeEnter > @dtsall Or TimeLeave > @dtsall Or TimeLeave is null )

*/
	if exists ( Select * FROM tempdb..sysobjects Where Id = object_id ( 'tempdb..#ush' ) )
		Drop Table #ush
	Create table #ush ( OperatorId uniqueidentifier, State int, TimeEnter DateTime, TimeLeave DateTime, Info nvarchar ( 100 ) collate database_default, ICode int )

	set @sqltext = 'Select OperatorId, State, TimeEnter, TimeLeave, case when selfinfo = 1 then Info else '''' end Info, ICode
		From A_CallCenter_UserStateHistory 
		Where ( TimeEnter > @dtt1 Or TimeLeave > @dtt1 Or TimeLeave is null ) And ( TimeEnter < @dtnow )'

	Insert Into #ush
		exec sp_executesql @sqltext, N'@dtt1 datetime, @dtnow datetime', @dtsall, @dtnow
	--Insert into @ush
	--	Select * FROM #tmpos02	

	--drop table #ush


--Declare @uit table ( Id uniqueidentifier, UserId uniqueidentifier, TaskId uniqueidentifier, EffortId uniqueidentifier, TimeStart DateTime, TimeStopPrior DateTime, TimeStopWaitCall DateTime, TimeStopBackCall DateTime, TimeStopDialog DateTime, TimeStopPost DateTime )
/*
Insert into @uit
	Select Id, UserId, TaskId, Effortid, IsNull ( TimeStart, @dtnow ), IsNull ( TimeStopPrior, @dtnow ), IsNull ( TimeStopWaitCall, @dtnow ), IsNull ( TimeStopBackCall, @dtnow ), IsNull ( TimeStopDialog, @dtnow ), IsNull ( TimeStopPost, @dtnow )
	From A_TaskManager_UserInTask
	Where TimeStart >= @dtsall or TimeStopPost >= @dtsall or TimeStopPost is null
*/
	if exists ( Select * FROM tempdb..sysobjects Where Id = object_id ( 'tempdb..#uit' ) )
		Drop Table #uit
	Create table #uit ( Id uniqueidentifier, UserId uniqueidentifier, TaskId uniqueidentifier, EffortId uniqueidentifier, TimeStart DateTime, TimeStopPrior DateTime, TimeStopWaitCall DateTime, TimeStopBackCall DateTime, TimeStopDialog DateTime, TimeStopPost DateTime )

	set @sqltext = 'Select Id, UserId, TaskId, Effortid, IsNull ( TimeStart, @dtnow ), IsNull ( TimeStopPrior, @dtnow ), IsNull ( TimeStopWaitCall, @dtnow ), IsNull ( TimeStopBackCall, @dtnow ), IsNull ( TimeStopDialog, @dtnow ), IsNull ( TimeStopPost, @dtnow )
	From A_TaskManager_UserInTask 
	Where ( TimeStart >= @dtt1 or TimeStopPost >= @dtt1 or TimeStopPost is null ) And ( TimeStart < @dtnow )'

	Insert Into #uit
		exec sp_executesql @sqltext, N'@dtt1 datetime, @dtnow datetime', @dtsall, @dtnow
	--Insert into @uit
	--	Select * FROM #uit	

	--drop table #uit


Declare @maxid table ( IdOperator uniqueidentifier, MaxId int )
	
	if exists ( Select * FROM tempdb..sysobjects Where Id = object_id ( 'tempdb..#tmpos04' ) )
		Drop Table #tmpos04
	Create table #tmpos04 ( IdOperator uniqueidentifier, MaxId int )

	-- Новое (06.2010)
	--   микс со временем, поскольку удалять записи будем все равно..
	set @sqltext = 'Select IdOperator,  Max ( Id )
	From [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]
	Where DateTimeStart < @dtm
	Group By IdOperator'

	Insert Into #tmpos04
		exec sp_executesql @sqltext, N'@dtm datetime', @dt10m
	Insert into @maxid
		Select * FROM #tmpos04	

	drop table #tmpos04
	

-- Распоследнее время для каждого оператора может быть уникальным
Declare @umaxdts table ( UserId uniqueidentifier, MaxDTS DateTime  )

Insert into @umaxdts
	Select IdOperator, Max ( DateTimeStop ) 
	From [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] With ( NOLOCK )
	Group By IdOperator

-- Новое (06.2010)
-- Будем перерасчитывать не менее 10 минут по любому...
Update @umaxdts
Set MaxDTS = @dt10m
Where MaxDTS > @dt10m

-- debug
--Select 'Время maxdts', MaxDTS From @umaxdts
--Where UserId = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8'



--print '   ## created all tables. Starting cursor cycle ' + Cast ( DatePart ( hh, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( mm, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ss, GetDate() ) as nvarchar ( 10 ))  + ':' + Cast ( DatePart ( ms, GetDate() ) as nvarchar ( 10 ) )	
--print '-----shared-sc- ms:  ' + Cast ( DatePart ( ss, GetDate() - @logdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @logdt ) as nvarchar ( 10 ) )
--Set @logdt = GetDate ( )


-- цикл по операторам
Begin Tran TranUpdateOperatorStates

Declare ucursor Cursor LOCAL FAST_FORWARD For 
	Select Id, Name From @settable
	--Where id = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8'

Declare @idoperator uniqueidentifier, @nameoperator nvarchar ( 100 )	

--Set @operlogdt = @dtnow

Open ucursor
Fetch Next From ucursor Into @idoperator, @nameoperator

While ( @@fetch_status = 0 )
   begin

	Declare @id uniqueidentifier
	Select @id = Id from [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]
	Where Id = @idoperator
	if ( @@rowcount = 0 )
		Insert 
		Into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] 
		( Id, Name ) Values ( @idoperator, @nameoperator )
				
	-- определяем время последнего изменения состояния
	Declare @dts DateTime, @dts1 DateTime
	
	Select @dts = MaxDTS
	From @umaxdts
	Where UserId = @idoperator
	
	Select @dts1 = LastDT
	From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] 
	Where Id = @idoperator
	
	if ( @dts1 > @dts ) or ( @dts is null )
		Set @dts = @dts1

	if ( @dts is null )
		set @dts = '01.01.2000'

	if ( @dts > @dt10m )
		set @dts = @dt10m

	-- Debug
	--Select 'MaxUserDTS', @dts

	--print '-----def------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
	--Set @operlogdt = GetDate ( )


	-- обновление производим для операторов не чаще одного раза в минуту
	if ( Cast ( @dtnow - @dts as float ) * 1440 > 1 )
	   begin		

		/*
		PriorHandle		= 1,
		WaitingCall		= 2,
		BackRing		= 3,
		TalkAbonent		= 4,
		TalkInside		= 5,
		InsideTalk		= 6,
		PostHandle		= 7,
		TalkOther		= 8,
		CCLunch			= 9,
		CCReady			= 10,
		System			= 11
		*/

		-----------------------------------------------------
		-- вторая таблица (статусы оператора в КЦ) ----------
		-----------------------------------------------------
		Declare @tempo2 table
		(
			State int not null,
			Priority int,
			DateTimeStart DateTime,
			DateTimeStop DateTime,
			Id int Identity ( 1, 1 ) not null primary key,
			Info nvarchar ( 100 ),
			ICode int
		)

		Delete From @tempo2

		-- 0-в системе, 1-в коллцентре, 2-онлайн, 3-перерыв
		-- 
		Insert into @tempo2 ( State, Priority, DateTimeStart, DateTimeStop, Info, ICode )
			Select State, Case when State in ( 3, 4 ) then 2 else 4 end, 
				TimeEnter, IsNull ( TimeLeave, @dtnow ), Info, ICode
			From #ush
			Where OperatorId = @idoperator
				And State in ( 2, 3, 4 )
				And ( TimeEnter > @dts Or TimeLeave > @dts Or TimeLeave is null )
		
		Update @tempo2
		Set State = Case When Priority = 2 then 9 else 10 end

		
		-- если есть активное состояние кц - обновляем
		if ( @@rowcount > 0 )
		begin	
			-- докидываем информацию по присутствию в системе
			Insert into @tempo2 ( State, Priority, DateTimeStart, DateTimeStop, Info, ICode )
				Select 11, 5, TimeEnter, IsNull ( TimeLeave, @dtnow ), Info, ICode
				From #ush
				Where OperatorId = @idoperator
					And State = 0
					And ( TimeEnter > @dts Or TimeLeave > @dts Or TimeLeave is null )

			Update @tempo2			
			Set 	DateTimeStart = Case When DateTimeStart < @dts then @dts else DateTimeStart end,
				DateTimeStop = Case When DateTimeStop > @dtnow then @dtnow else DateTimeStop end
			

			--print '-----t2--------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

	
			-----------------------------------------------------
			-- Первая таблица (статусы оператора в задачах) -----
			-----------------------------------------------------
			Declare @tempo1 table
			(
				IdTask 		uniqueidentifier,
				IsOutput	bit,
				IdOperator 	uniqueidentifier,
				CallResult	int,
				State		int not null,
				StateCat	int,
				DateTimeStart 	DateTime,
				DateStart 	DateTime,
				TimeStart 	DateTime,
				DateTimeStop 	DateTime,
				LenTime 	Float,
				IdEffort	uniqueidentifier,
				Priority	int,
				Id		int identity ( 1, 1 ) not null primary key
			)

			Delete From @tempo1
			
			Declare @uito table 
			(
				Id uniqueidentifier,
				UserId uniqueidentifier,
				TaskId uniqueidentifier,	
				EffortId uniqueidentifier,
				TimeStart DateTime,
				TimeStopPrior DateTime,
				TimeStopWaitCall DateTime,
				TimeStopBackCall DateTime,
				TimeStopDialog DateTime,
				TimeStopPost DateTime
			)

			Delete From @uito

			Insert Into @uito
			Select *
			From #uit
			Where UserId = @idoperator
				--And ( TimeStart > @dts or TimeStopPost > @dts or TimeStopPost is null )

			--print '-----t1-crtemp-- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )
		

			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,
						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 1, 0, 
					TimeStart, 
					TimeStopPrior
				From @uito--#t
				Where Cast ( TimeStopPrior - TimeStart as float ) * 86400 > 0
			
			--print '-----t1-cra----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )
			
			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,

						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 2, 0, 
					TimeStopPrior, 
					TimeStopWaitCall
				From @uito--#t
				Where Cast ( TimeStopWaitCall - TimeStopPrior as float ) * 86400 > 0

			--print '-----t1-crb----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )


			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,
						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 3, 0, 
					TimeStopWaitCall, 
					TimeStopBackCall
				From @uito--#t
				Where Cast ( TimeStopBackCall - TimeStopWaitCall as float ) * 86400 > 0

			--print '-----t1-crc----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,
						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 6, 0, 
					TimeStopBackCall, 
					TimeStopDialog
				From @uito--#t
				Where Cast ( TimeStopDialog - TimeStopBackCall as float ) * 86400 > 0

			--print '-----t1-crd----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

			Insert into @tempo1 ( IdTask, IsOutput, IdEffort, IdOperator, Priority, CallResult, State, StateCat,
						DateTimeStart, DateTimeStop )
				Select TaskId, null, EffortId, @idoperator, 1, null, 7, 0, 
					TimeStopDialog,
					TimeStopPost
				From @uito--#t
				Where Cast ( IsNull ( TimeStopPost, @dtnow ) - IsNull ( TimeStopDialog, @dtnow ) as float ) * 86400 > 0

			--print '-----t1-cre----- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )


			-- время начала и время конца по периоду
			Update @tempo1 
			Set 	DateTimeStart = case 	When ( DateTimeStart < @dts ) then @dts 
							else DateTimeStart end,
		 		DateTimeStop = case 	When ( DateTimeStop > @dtnow ) then @dtnow 
							When ( DateTimeStop < @dts ) then @dts 
							else DateTimeStop end

			Delete From @tempo1
			Where DateTimeStart = DateTimeStop


			-- проставляем флаг исх/вх задачи
			Update tmpo
			Set IsOutput = t.IsOutputTask
			From @tempo1 tmpo, A_TaskManager_Tasks t
			Where tmpo.IdTask = t.Id

			-- проставляем результат выполнения задачи
			Update tmpo
			Set CallResult = tic.CallResult
			From @tempo1 tmpo, A_TaskManager_Task_IncomingCalls tic
			Where tmpo.IdEffort = tic.Id

			Update tmpo
			Set CallResult = ste.EResult
			From @tempo1 tmpo, A_TaskManager_SubTaskEfforts ste
			Where tmpo.IdEffort = ste.Id

			--if ( @idoperator = '5776C54C-C60D-4E48-B64C-9FA11A89F558' )
			--Select * FROM @tempo1

			--Select * FROM A_Taskmanager_UserInTask


			--print '-----t1-up------ ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )
	
			-----------------------------------------------------
			-- третья таблица (Разговоры) -----------------------
			-----------------------------------------------------
			
			Declare @tempo3 table
			(
				State int not null,
				Priority int,
				DateTimeStart DateTime,
				DateTimeStop DateTime,
				Id int identity ( 1, 1 ) not null primary key
			)
			
			Delete From @tempo3
						
			Insert into @tempo3
				Select 8, 0, TimeStart, isnull ( TimeStop, @dtnow )
				From #sc
				Where ( AUserId = @idoperator Or BUserId = @idoperator )
					And ( TimeStart > @dts Or TimeStop > @dts Or TimeStop is null )
					And FromCC = 0
				/*
				Select Case When FromCC = 0 then 8 When IsBetweenUsers = 1 then 5 else 4 end, 0,
					TimeStart, isnull ( TimeStop, @dtnow )
				From #sc
				Where ( AUserId = @idoperator Or BUserId = @idoperator )
					And ( TimeStart > @dts Or TimeStop > @dts Or TimeStop is null )
				*/

			Update @tempo3
			Set DateTimeStart = Case When DateTimeStart < @dts then @dts else DateTimeStart end,
				Priority = Case When State = 8 then 3 else 0 end
			
			
			--print '-----t3--------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

			-----------------------------------------------------
			-- Формируем времянку по точкам ---------------------
			-----------------------------------------------------

	--		Select * FROM @tempo1
	--		Select * FROM @tempo2
	--		Select * From @tempo3

	--		Select * FROM @tempo1 Where DateTimeStart > '13.02.2007' Order by DateTimeStart
	--		Select * FROM @tempo2 Where DateTimeStart > '13.02.2007' Order by DateTimeStart
	--		Select * From @tempo3 Where DateTimeStart > '13.02.2007' Order by DateTimeStart

		
			Declare @tempo table
			(
				TableN int,
				TableID int,
				State int not null,
				Priority int,
				DT DateTime,
				NK bit
			)

			Delete from @tempo

			Insert into @tempo
				Select 1, Id, State, Priority, DateTimeStart, 0
				From @tempo1

			Insert into @tempo
				Select 1, Id, State, Priority, DateTimeStop, 1
				From @tempo1

			Insert into @tempo
				Select 2, Id, State, Priority, DateTimeStart, 0
				From @tempo2

			Insert into @tempo
				Select 2, Id, State, Priority, DateTimeStop, 1
				From @tempo2

			Insert into @tempo
				Select 3, Id, State, Priority, DateTimeStart, 0
				From @tempo3

			Insert into @tempo
				Select 3, Id, State, Priority, DateTimeStop, 1
				From @tempo3
			
			--Select * From @tempo Order By DT

			-- В Tempo2 лежат ICode, но так как состояние перерыва фактически будет по концу коммутации, если оная была
			--   а пересечение с Tempo2 по времени, то нужно добавить в Tempo2 куски из других таблиц, но с их временами,
			--   и расширить предыдущим ICode для пересечения



			--print '-----tpt-------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )
		
			-----------------------------------------------------
			-- пробегаем курсором -------------------------------
			-----------------------------------------------------

			Declare @res table ( TableN int, Id int, State int not null, Priority int, DStart DateTime, DStop DateTime )
			Delete From @res

			-- определяем статусы и приоритеты на начало периода расчета
			-- приоритеты: 	0 - коммутации внутри задачи ( попытки )
			--		1 - состояния оператора внутри задачи ( попытки )
			--		2 - перерывы
			--		3 - прочие коммутации
			--		4 - онлайн в КЦ
			--		5 - онлайн в системе
			Declare @p0 int, @p1 int, @p2 int, @p3 int, @p4 int, @p5 int
			Declare @s0 int, @s1 int, @s2 int, @s3 int, @s4 int, @s5 int
			Declare @t0 int, @t1 int, @t2 int, @t3 int, @t4 int, @t5 int
			Declare @i0 int, @i1 int, @i2 int, @i3 int, @i4 int, @i5 int

			-- Новое (06.2010)
			--   Не применяем предыдущую историю количеств. Всегда должно в ноль сводиться
			Select @p0 = 0, @p1 = 0, @p2 = 0, @p3 = 0, @p4 = 0, @p5 = 0
			Select --@p0 = IsNull ( P0, 0 ), @p1 = IsNull ( P1, 0 ), @p2 = IsNull ( P2, 0 ), @p3 = IsNull ( P3, 0 ), @p4 = IsNull ( P4, 0 ), @p5 = IsNull ( P5, 0 ),
				@s0 = IsNull ( S0, 0 ), @s1 = IsNull ( S1, 0 ), @s2 = IsNull ( S2, 0 ), @s3 = IsNull ( S3, 0 ), @s4 = IsNull ( S4, 0 ), @s5 = IsNull ( S5, 0 )
			From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] 
			Where Id = @idoperator
		
			-- формируем сдвоенную таблицу	
			Declare @tempo_ordered table
			(
				Id int identity ( 1, 1 ) not null,
				TableN int,
				TableID int,
				State int not null,
				Priority int,
				DT DateTime,
				NK bit
			)

			Delete From @tempo_ordered

			Insert into @tempo_ordered ( TableN, TableID, State, Priority, DT, NK )
				Select TableN, TableID, State, Priority, DT, NK From @tempo
				Order By DT

			--if ( @idoperator = '5776C54C-C60D-4E48-B64C-9FA11A89F558' )
			--Select * From @tempo_ordered


			Declare @tempo_joined table
			(
				o1 int, o2 int, s1 int not null, p1 int not null, s2 int not null, p2 int not null, dstart datetime, dstop datetime, nk1 bit, nk2 bit, t1 int, t2 int, i1 int, i2 int
			)
			Delete From @tempo_joined
		
			Insert into @tempo_joined 
				Select t1.Id, t2.Id, t1.State as s1, t1.Priority as p1, t2.State as s2, t2.Priority as p2,
					t1.DT as dstart, t2.DT as dstop, t1.NK as nk1, t2.NK as nk2,
					t1.TableN, t2.TableN, t1.TableID, t2.TableID
				From @tempo_ordered t1
					Inner join @tempo_ordered t2 on t1.Id + 1 = t2.Id


			--if ( @idoperator = '5776C54C-C60D-4E48-B64C-9FA11A89F558' )
			--Select * FROM @tempo_joined

			--print '-----tjnd------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

-- debug
--Select 'tempo_o', * From @tempo_ordered


-- debug
--Select 'tempo_j', o1, o2, s1, p1, s2, p2, dstart, dstop, nk1, nk2, t1, t2, i1, i2 
--From @tempo_joined
--Order by o1

			-- курсором бежим и заполняем таблицу результата 
			Declare tcursor Cursor LOCAL FAST_FORWARD For 
				Select o1, o2, s1, p1, s2, p2, dstart, dstop, nk1, nk2, t1, t2, i1, i2 
				From @tempo_joined
				Order by o1
				--Where dstart > '21.02.2007'

			Declare @o1 int, @o2 int
			Declare @st1 int, @pr1 int, @st2 int, @pr2 int, @dstart DateTime, @dstop DateTime, @nk1 bit, @nk2 bit, @tb1 int, @tb2 int, @id1 int, @id2 int
			Declare @actualst int, @actualpr int, @actualt int, @actualid int
			Declare @lastst int, @lastpr int, @lastt int, @lastid int, @lastdstart datetime, @lastdstop datetime
			Declare @dontinsert bit, @updatelast bit
			Declare @insertindex int

			set @insertindex = 0
			set @lastt = 0
			set @dontinsert = 1 -- чтобы при втором обновлении (при существующей таблице данных) не вставляло имеющееся
		
			Open tcursor
			Fetch Next From tcursor Into @o1, @o2, @st1, @pr1, @st2, @pr2, @dstart, @dstop, @nk1, @nk2, @tb1, @tb2, @id1, @id2

			While @@FETCH_STATUS = 0
   			Begin
--				print Cast ( @st1 as nvarchar ( 10 ) ) + '  ' + Cast ( @pr1 as nvarchar ( 10 ) ) + '  ' + Cast (  @st2 as nvarchar ( 10 ) ) + '  ' + Cast (  @pr2 as nvarchar ( 10 ) )  + '  //  ' +
--					Cast ( @nk1 as nvarchar(2) ) + '  ' + cast ( @nk2 as nvarchar(2) )  + '  //  ' + 
--					Cast ( IsNull ( @lastst, -1 ) as nvarchar ( 10 ) ) + '  ' + Cast ( IsNull ( @lastpr, -1 ) as nvarchar ( 10 ) )  + '  //  ' + 
--					Cast ( @p0 as nvarchar ( 10 ) ) + '  ' + Cast ( @p1 as nvarchar ( 10 ) ) + '  ' + Cast (  @p2 as nvarchar ( 10 ) ) + '  ' + Cast (  @p3 as nvarchar ( 10 ) ) + '  ' + Cast (  @p4 as nvarchar ( 10 ) ) + '  ' + Cast (  @p5 as nvarchar ( 10 ) ) + '  //  ' +
--					Convert ( nvarchar(100), @dstart, 121 ) + '   ' + Convert ( nvarchar(100), @dstop, 121 ) + '  // ids ' + 
--					Cast ( @o1 as nvarchar ( 10 ) ) + '  ' + Cast ( @o2 as nvarchar ( 10 ) )

				--- оцениваем перед началом -----		
				if ( @nk1 = 0 )
				begin			
					if ( @pr1 = 0 )
					begin
			    			set @p0 = @p0 + 1
				    		set @s0 = @st1				
						set @t0 = @tb1	
						set @i0 = @id1
					end
					else if ( @pr1 = 1 )
					begin
				    		set @p1 = @p1 + 1
				    		set @s1 = @st1
						set @t1 = @tb1
						set @i1 = @id1
					end
					else if ( @pr1 = 2 )
					begin
			    			set @p2 = @p2 + 1
				    		set @s2 = @st1
						set @t2 = @tb1
						set @i2 = @id1
					end
					else if ( @pr1 = 3 )
					begin
				    		set @p3 = @p3 + 1
				    		set @s3 = @st1
						set @t3 = @tb1
						set @i3 = @id1
					end
					else if ( @pr1 = 4 )
					begin
			    			set @p4 = @p4 + 1
				    		set @s4 = @st1
						set @t4 = @tb1
						set @i4 = @id1
					end
					else if ( @pr1 = 5 )
					begin
						set @p5 = @p5 + 1
						set @s5 = @st1
						set @t5 = @tb1
						set @i5 = @id1
					end
				end

				-- Debug
				--print Cast ( @st1 as nvarchar ( 10 ) ) + '  ' + Cast ( @pr1 as nvarchar ( 10 ) ) + '  ' + Cast (  @st2 as nvarchar ( 10 ) ) + '  ' + Cast (  @pr2 as nvarchar ( 10 ) )  + '  //  ' +
				--	Cast ( @nk1 as nvarchar(2) ) + '  ' + cast ( @nk2 as nvarchar(2) )  + '  //  ' + 
				--	Cast ( IsNull ( @lastst, -1 ) as nvarchar ( 10 ) ) + '  ' + Cast ( IsNull ( @lastpr, -1 ) as nvarchar ( 10 ) )  + '  //  ' + 
				--	Cast ( @p0 as nvarchar ( 10 ) ) + '  ' + Cast ( @p1 as nvarchar ( 10 ) ) + '  ' + Cast (  @p2 as nvarchar ( 10 ) ) + '  ' + Cast (  @p3 as nvarchar ( 10 ) ) + '  ' + Cast (  @p4 as nvarchar ( 10 ) ) + '  ' + Cast (  @p5 as nvarchar ( 10 ) ) + '  //  ' +
				--	Convert ( nvarchar(100), @dstart, 121 ) + '   ' + Convert ( nvarchar(100), @dstop, 121 ) + '  // ids ' + 
				--	Cast ( @o1 as nvarchar ( 10 ) ) + '  ' + Cast ( @o2 as nvarchar ( 10 ) )


				--- производим расчет и модернизацию
				set @dontinsert = 0
				if ( @p0 > 0 )
				begin
					set @actualst = @s0
					set @actualpr = 0
					set @actualt = @t0
					set @actualid = @i0
				end
				else if ( @p1 > 0 )
				begin
					set @actualst = @s1
					set @actualpr = 1
					set @actualt = @t1
					set @actualid = @i1

				end
				else if ( @p2 > 0 )
				begin
					set @actualst = @s2
					set @actualpr = 2
					set @actualt = @t2
					set @actualid = @i2
				end
				else if ( @p3 > 0 )
				begin
					set @actualst = @s3
					set @actualpr = 3
					set @actualt = @t3
					set @actualid = @i3
				end
				else if ( @p4 > 0 )
				begin
					set @actualst = @s4
					set @actualpr = 4
					set @actualt = @t4
					set @actualid = @i4
				end
		
				-- если не покрывается кусок 4 и 2 уровнями (онлайн и перерыв)
				-- или юзер в офлайне вообще в этом промежутке
				if (( @p4 = 0 ) and ( @p2 = 0 )) or ( @p5 = 0 )
 				    set @dontinsert = 1
			
				--Debug
				--print '@dontinsert ' + Cast ( @dontinsert as nvarchar(10) )

				--print Convert ( nvarchar ( 10 ), @dstart, 108 ) + ' ' + convert ( nvarchar ( 10 ), @dstop, 108 ) + ' state1=' + cast ( @st1 as nvarchar ( 10 ) ) + ' state2=' + cast ( @st2 as nvarchar ( 10 ) ) + ' nk1=' + cast ( @nk1 as nvarchar ( 10 ) ) + ' nk2=' + cast ( @nk2 as nvarchar ( 10 ) )

				-- разбор состояния на необходимость вставки			
				set @updatelast = 0
				-- если предыдущий был пустым блоком, или самое начало - обновляем величины
				if ( @lastt = 0 or @lastt is null )
				begin
					--print 'lastt = 0'
					set @updatelast = 1
					--print 'res 1, updatelast'
				end
				-- если активный блок но статус совпадает с предыдущим блоком - обновляем время конца
				else if ( @dontinsert = 0 ) and ( @actualst = @lastst )
				begin
					--print 'lastst = actualst' + Cast ( @actualst as nvarchar ( 10 ))
					set @lastdstop = @dstop
					--print 'res 2, lastdstop'
				end		
				-- в противном случае вставляем и обновляем величины
				else
				begin
					--print 'insert time=' + Convert ( nvarchar ( 10 ), @lastdstart, 108 ) + '-' + convert ( nvarchar ( 10 ), @lastdstop, 108 ) + ' state=' + cast ( @lastst as nvarchar ( 10 ) )
					if ( DateDiff ( ms, @lastdstart, @lastdstop ) > 10 ) 
						Insert Into @res
						Values ( @lastt, @lastid, @lastst, @lastpr, @lastdstart, @lastdstop )
				
					set @updatelast = 1
					--print 'res 3, updatelast'
				end
			
				if ( @updatelast = 1 )
				begin
					if ( @dontinsert = 1 )
			  			set @lastt = 0
					else
 					begin
						set @lastt = @actualt
						set @lastid = @actualid
						set @lastst = @actualst
						set @lastpr = @actualpr
						set @lastdstart = @dstart
						set @lastdstop = @dstop
					end
				end
			
		
				--- оцениваем после вставки (конец) -----
				if ( @nk2 = 1 )
				begin
					-- Новое (06.2010)
					--    Условие на неотрицательность

					--print '<<'
					if ( @pr2 = 0 ) begin
						if ( @p0 > 0 ) set @p0 = @p0 - 1 
						--print 'p0 <<'
						end
					else if ( @pr2 = 1 ) begin
						if ( @p1 > 0 ) set @p1 = @p1 - 1 
						--print 'p1 <<'
						end
					else if ( @pr2 = 2 ) begin
						if ( @p2 > 0 ) set @p2 = @p2 - 1 
						--print 'p2 <<'
						end
					else if ( @pr2 = 3 ) begin
						if ( @p3 > 0 ) set @p3 = @p3 - 1 
						--print 'p3 <<'
						end
					else if ( @pr2 = 4 ) begin
						if ( @p4 > 0 ) set @p4 = @p4 - 1 
						--print 'p4 <<'
						end
					else if ( @pr2 = 5 ) begin
						if ( @p5 > 0 ) set @p5 = @p5 - 1 
						--print 'p5 <<'
						end
				end
			
				Fetch Next From tcursor Into @o1, @o2, @st1, @pr1, @st2, @pr2, @dstart, @dstop, @nk1, @nk2, @tb1, @tb2, @id1, @id2
			End


			-- в конце последний промежуток надо втавить, так как алгоритм запаздывающий
			if ( @dontinsert = 0 )
				if ( DateDiff ( ms, @lastdstart, @lastdstop ) > 10 ) 
					Insert Into @res
					Values ( @lastt, @lastid, @lastst, @lastpr, @lastdstart, @lastdstop )

			Close tcursor
			Deallocate tcursor

			--print '-----curs------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

			-------------------------------------------------------------------------------------------------
			-- обновляем данные по таблицам и формируем итоговую по оператору -------------------------------
			-------------------------------------------------------------------------------------------------

			--проверяем наличие записи об операторе в таблице (местами надо поменять с куском обновления и вставки в куб)
			Update [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]
				Set 	p0 = @p0, p1 = @p1, p2 = @p2, p3 = @p3, p4 = @p4, p5 = @p5,
					s0 = @s0, s1 = @s1, s2 = @s2, s3 = @s3, s4 = @s4, s5 = @s5,
					LastDT = @dtnow
			Where Id = @idoperator

			Declare @operatorstates table
			(
				Id		int identity ( 1, 1 ) not null primary key,
				IdTask 		uniqueidentifier,
				IsOutput	bit,
				IdOperator 	uniqueidentifier,
				CallResult	int,
				State		int not null,
				DateTimeStart 	DateTime,
				DateStart 	DateTime,
				TimeStart 	DateTime,
				DateTimeStop 	DateTime,
				LenTime 	Float,
				ICode		int,
				IdEffort	uniqueidentifier
			)

			Delete From @operatorstates

			Insert into @operatorstates ( IdOperator, State, DateTimeStart, DateTimeStop, DateStart, TimeStart, LenTime, 
				ICode, IdTask, IsOutput, CallResult, IdEffort )
			Select @idoperator, r.State, r.DStart, r.DStop,
				Cast ( Floor ( Cast ( DStart as Float ) ) as DateTime ),
				Cast ( Cast ( DStart as float ) - Floor ( Cast ( DStart as Float ) ) as DateTime ),				
				Cast ( DStop - DStart as float ) * 86400,
				t2.ICode,
				IdTask, IsOutput, CallResult, IdEffort
			From @res r
				Left join @tempo1 t1 on t1.Id = r.Id and r.TableN = 1
				Left join @tempo2 t2 on t2.State = r.State and t2.DateTimeStart = r.DStart


			-- В Tempo2 лежат ICode, но так как состояние перерыва фактически будет по концу коммутации, если оная была
			--   а пересечение с Tempo2 по времени, то нужно обновить потом ICode там где не проставился, а в Tempo2 есть
			Update os
			Set os.ICode = t2.ICode
			From @operatorstates os, @tempo2 t2
			Where (( os.State = 9 ) and ( os.ICode is NULL ))
				and ( t2.State = 9)
				and ( t2.DateTimeStart < os.DateTimeStart and t2.DateTimeStop > os.DateTimeStart )


--Select * From oktell_cc_temp.dbo.A_Cube_CC_OperatorStates os order by DateTimeStart Desc

-- debug
--Select '@operatorstates', * From @operatorstates

			-- Код крайней остающейся записи в кубе в настоящее время
			Declare @idt1 int
			Select @idt1 = MaxId
			From @maxid
			Where IdOperator = @idoperator

			-- Новое (06.2010)
			--    удаляем последние 10 минут
			-- i. IdOperator, DateTimeStart
			Delete From [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]
			Where IdOperator = @idoperator
				--And Id > @idt1
				And DateTimeStart >= @dts

-- debug
--Select 'after delete', * 
--From [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]
--Where idoperator = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8'

			--   Обратно возвращаем на стык значение DateTimeStop
			if ( not @idt1 is null )  begin
			    Update [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] --With ( UpdLock )
			    Set DateTimeStop = @dts,
				LenTime = Cast ( @dts - DateTimeStart as float ) * 86400
			    Where Id = @idt1
				And DateTimeStop > @dts
			end

--Select 'updback', @dts, @idt1, @@rowcount


-- debug
--Select 'after upd back', * 
--From [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]
--Where idoperator = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8'

			--для склейки результатов выполнения задач (если расчет в середине выполнения - в первые состояния информация о результате не попала)
			Declare @cr table ( idtask uniqueidentifier, ideffort uniqueidentifier, callresult int )
			Insert into @cr ( idtask, ideffort, callresult )
				Select IdTask, IdEffort, CallResult
				From @operatorstates
				Group By IdTask, IdEffort, CallResult

			-- i. IdOperator, IdEffort, IdTask, CallResult
			Update os
			Set CallResult = cr.callresult
			From [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] os, @cr cr
			Where os.IdOperator = @idoperator
				and os.IdEffort = cr.ideffort
				and not ( cr.IdEffort is null )
				and os.CallResult is null

			-- код склейки крайних записей
			Declare @state1 int, @dtstart1 DateTime, @dtstop1 DateTime
			
			if ( not @idt1 is null )
			   begin
				Select @state1 = State, @dtstart1 = DateTimeStart, @dtstop1 = DateTimeStop 
				From [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] --With ( TabLock )
				Where Id = @idt1
				
				Declare @idt2 int, @state2 int, @dtstart2 DateTime, @dtstop2 DateTime
				Select Top 1 @idt2 = Id, @state2 = State, @dtstart2 = DateTimeStart, @dtstop2 = DateTimeStop
				From @operatorstates
				Order By DateTimeStart

				if ( @state1 = @state2 ) and ( @dtstart2 = @dtstop1 )
				   begin
					Update [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] --With ( UpdLock )
					Set 	DateTimeStop = @dtstop2,
						LenTime = Cast ( @dtstop2 - @dtstart1 as float ) * 86400
					Where Id = @idt1

					Delete From @operatorstates
					Where Id = @idt2
			   	   end
			   end

		
			-- обновление куба
			Insert Into [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] --With ( UpdLock )
				( IdTask, IsOutput, IdOperator, CallResult, State, DateTimeStart, DateStart, TimeStart, DateTimeStop, LenTime, ICode, IdEffort )
				Select IdTask, IsOutput, IdOperator, CallResult, State, DateTimeStart, DateStart, TimeStart, DateTimeStop, LenTime, ICode, IdEffort
				From @operatorstates
			
			--print '-----ins-------- ms:  ' + Cast ( DatePart ( ss, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @operlogdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
			--Set @operlogdt = GetDate ( )

		end
		else
		begin
			Update [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]
			Set LastDT = @dtnow
			Where Id = @idoperator
		end

	   end
	
	--print '--------------------------------------oper--- ms:  ' + Cast ( DatePart ( ss, GetDate() - @logdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @logdt ) as nvarchar ( 10 ) ) + '   ' + @nameoperator
	--Set @logdt = GetDate ( )
	--Set @operlogdt = GetDate ( )

	Fetch Next From ucursor Into @idoperator, @nameoperator
   end

Close ucursor
Deallocate ucursor

--print '------------------------------------finish--- ms:  ' + Cast ( DatePart ( ss, GetDate() - @fulllogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @fulllogdt ) as nvarchar ( 10 ) )

	
--Select * FROM [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]
--Order by Datetimestart

--print '------------------------------------finish--- ms:  ' + Cast ( DatePart ( ss, GetDate() - @fulllogdt ) as nvarchar ( 10 ) ) + ':' + Cast ( DatePart ( ms, GetDate() - @fulllogdt ) as nvarchar ( 10 ) )

Commit Tran TranUpdateOperatorStates
	
end
GO
