﻿---------------------------------------------
------- DISTR DIRECT Refresh Operator
---------------------------------------------

if exists ( select * from sysobjects where id= object_id ( 'dbo.A_TaskManager_List_DistrDirectDB_RefreshOperatorP' ))
	Drop procedure dbo.A_TaskManager_List_DistrDirectDB_RefreshOperatorP
GO

Create procedure dbo.A_TaskManager_List_DistrDirectDB_RefreshOperatorP
	@taskid uniqueidentifier,
	@operatorid uniqueidentifier,
	@listtable nvarchar ( 1000 ) = '',
	@listquery nvarchar ( 4000 ) = '',
	@listidfield nvarchar ( 200 ) = '',
	@listnamefield nvarchar ( 200 ) = '',
	@count int = 0,
	@letter1 char ( 1 ) = '',
	@letter2 char ( 1 ) = '',
	@providername nvarchar(500) = 'SQLOLEDB',
	@connectstring nvarchar(4000) = ''	
as
begin
---------------------------------
/*
Declare @taskid uniqueidentifier,
	@operatorid uniqueidentifier,
	@listtable nvarchar ( 1000 ),
	@listquery nvarchar ( 4000 ),
	@listidfield nvarchar ( 200 ),
	@listnamefield nvarchar ( 200 ),
	@count int,
	@letter1 char ( 1 ),
	@letter2 char ( 1 ),
	@providername nvarchar(500),
	@connectstring nvarchar(4000)

Select  @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF',
	@operatorid = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8',
	@listtable = '',
	@listquery = 'Select * From T_X Where id < 2000',
	@listidfield = 'Id',
	@listnamefield = 'Name',
	@count = 0,
	@letter1 = 'a',
	@letter2 = 'c',
	@providername = 'SQLOLEDB',
	@connectstring = 'server=PROGRAMMER;database=oktell;uid=sa;pwd=123;'	
--*/
---------------------------------
	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @operator nvarchar ( 60 )
	set @operator = '''' + cast ( @operatorid as nvarchar ( 50 ) ) + ''''

	declare @sql nvarchar ( 4000 )

	-- создаем таблицу для задачи, если ее нет еще
	if exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		if ( @count > 0 )
		    -- Исполняется в SQL родном всегда
  		    Set @sql = '
			SET ROWCOUNT ' + cast ( @count as nvarchar ( 10 ) ) + '

			Update ' + @tableidx + ' 
			Set IdOperator = ' + @operator + '
			Where IdOperator is null

			SET ROWCOUNT 0
			'

		else if (( @letter1 != '' ) and ( @letter2 != '' ) and ( @listtable != '' ) and ( @listnamefield != '' ))
		    -- Может быть исполнена только в SQL из-за cast и substring
		    Set @sql = '
			if exists ( select * from tempdb..sysobjects where id=object_id(''tempdb..#tcache''))
				Drop table #tcache

			Select t.[' + @listidfield + '] as idc into #tcache
			From OPENROWSET(''' + @providername + ''',''' + @connectstring + ''', 
				''Select Distinct [' + @listidfield + '] 
				From ' + @listtable + ' 
				Where Cast ( Substring ( [' + @listnamefield + '], 1, 1 ) as char ( 1 ) ) between ''''' + @letter1 + ''''' and ''''' + @letter2 + '''''
				'' ) t 

			Update a
			Set IdOperator = ' + @operator + '
			From ' + @tableidx + ' a, #tcache b
			Where a.Id = b.idc
			
			Drop table #tcache
			'

		else if (( @letter1 != '' ) and ( @letter2 != '' ) and ( @listquery != '' ) and ( @listnamefield != '' ))
		    -- Может быть исполнена только в SQL из-за cast и substring
		    Set @sql = '
			if exists ( select * from tempdb..sysobjects where id=object_id(''tempdb..#tcache''))
				Drop table #tcache

			Select t.[' + @listidfield + '] as idc into #tcache
			From OPENROWSET(''' + @providername + ''',''' + @connectstring + ''', 
				''Select Distinct [' + @listidfield + '] 
				From (' + @listquery + ') a 
				Where Cast ( Substring ( [' + @listnamefield + '], 1, 1 ) as char ( 1 ) ) between ''''' + @letter1 + ''''' and ''''' + @letter2 + '''''
				'' ) t 

			Update a
			Set IdOperator = ' + @operator + '
			From ' + @tableidx + ' a, #tcache b
			Where a.Id = b.idc
			
			Drop table #tcache
			'

		else 
		    Set @sql = '
			Update ' + @tableidx + ' 
			Set IdOperator = NULL
			Where IdOperator = ''00000000-0000-0000-0000-000000000000'''

			
		exec sp_executesql @sql
	end
end
GO

---------------------------------------------
------- DISTR DIRECT CreateCacheIdNum 
---------------------------------------------

if exists ( select * from sysobjects where id= object_id ( 'dbo.A_TaskManager_List_DistrDirectDb_IdNumCache_CreateP' ))
	Drop procedure dbo.A_TaskManager_List_DistrDirectDb_IdNumCache_CreateP
GO

Create procedure dbo.A_TaskManager_List_DistrDirectDb_IdNumCache_CreateP
	@taskid uniqueidentifier,
	@table nvarchar ( 100 ) = '',
	@query nvarchar ( 4000 ) = '',
	@colid nvarchar ( 100 ),
	@colsphone nvarchar ( 1000 ) = '',
	@colsphonebasic nvarchar ( 1000 ) = '',
	@providername nvarchar(500) = 'SQLOLEDB',
	@connectstring nvarchar(4000) = ''	
as
begin


--------------------------------------
/*
Declare @taskid uniqueidentifier,
	@table nvarchar ( 200 ),
	@query nvarchar ( 4000 ),
	@colid nvarchar ( 100 ),
	@colsphone nvarchar ( 1000 ),
	@colsphonebasic nvarchar ( 1000 ),
	@providername nvarchar(500),
	@connectstring nvarchar(4000)

Select @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF',
	@table = '',
	@query = 'Select * from dbo.T_X Where id < 2000',
	@colid = 'id',
	@colsphone = ' IsNull ( [phone1], '''' ) + '', '' + IsNull ( [phone2], '''' )',
	@colsphonebasic = ' [phone1], [phone2] ',
	--@providername = 'SQLOLEDB',
	--@connectstring = 'server=PROGRAMMER;database=oktell;uid=sa;pwd=123;'	
	@providername = 'SQLOLEDB',
	@connectstring = 'server=PETER;database=oktell;uid=sa;pwd=123;'	
--*/
--------------------------------------
	--Теперь на уровень выше
	--Select @colsphone = Replace ( @colsphone, '''', '''''' )

	declare @temptable nvarchar (100 )
	set @temptable = 'dbo.[t_cache1_' + cast ( @taskid as nvarchar (100 ) ) + ']'

	declare @temptable2 nvarchar (100 )
	set @temptable2 = 'dbo.[t_cache2_' + cast ( @taskid as nvarchar (100 ) ) + ']'

	declare @tableidx nvarchar (100), @tableidxconstr nvarchar ( 100 )
	set @tableidx = 'dbo.[A_TaskManager_dIdxn_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	set @tableidxconstr = 'A_TaskManager_dIdxn_' + cast ( @taskid as nvarchar ( 50 ) )
	


	declare @sql nvarchar ( 4000 )

	----------------------

	set @sql = '
		If not exists ( select * FROM sysobjects where id = object_id ( ''' + @tableidx + ''' ) )
			Create Table ' + @tableidx + ' ( id int not null, Phone nvarchar ( 50 ) collate database_default not null )
		'

	exec sp_executesql @sql

	set @sql = '
		if not exists ( select s.name, s.parent_obj, s1.name from sysobjects s
			inner join sysobjects s1 on s.parent_obj = s1.Id where s.name like ''PK_' + @tableidxconstr + ''' )
			ALTER TABLE ' + @tableidx + ' ADD CONSTRAINT [PK_' + @tableidxconstr + '] PRIMARY KEY CLUSTERED 
			( [Id], [Phone] )  ON [PRIMARY] 
		'
			
	exec sp_executesql @sql

	set @sql = 'Truncate table ' + @tableidx

	exec sp_executesql @sql

	----------------------
	
	
	----------------------
	
	if exists ( select * from tempdb..sysobjects where id = object_id ( 'tempdb..#temptable'))
		Drop table #temptable

	set @sql = '
	
		if exists ( select * from sysobjects where id = object_id ( ''' + @temptable + ''' ) )
			drop table ' + @temptable + ' 
		'

	exec sp_executesql @sql
	
	----------------------

	if exists ( select * from tempdb..sysobjects where id = object_id ( 'tempdb..#temptable2'))
		Drop table #temptable2

	set @sql = '
	
		if exists ( select * from sysobjects where id = object_id ( ''' + @temptable2 + ''' ) )
			drop table ' + @temptable2 + ' 
		'

	exec sp_executesql @sql
	
	-----------------------

	-- Пробел разделитель?
	Declare @spacesep bit
	Select @spacesep = case when ( valueint = 1 ) then 1 else 0 end
	From A_Settings 
	Where [name] like 'us~~~~b_UseDividerSpaceInNumbers'
	
	-----------------------------------

	-- Все телефоны объединяем в одну строчку через запятую без пропусков
	declare @dt datetime, @dt1 datetime
	set @dt = GetDate()

	set @sql = '
		Create table ' + @temptable + ' ( [Id] int, [Phone] nvarchar(4000) collate database_default )

		Insert into ' + @temptable + ' ( [Id], [Phone] )
			Select [Id], [Phone]
			From ( 	Select [Id], 
					Replace ( Replace ( Replace (
					Replace ( Replace ( Replace (
					Replace ( Replace ( Replace (
					Replace ( Replace (
						''^'' + ' + @colsphone + ' + ''$'', 
						''^, '', ''^'' ), ''^, '', ''^'' ), ''^, '', ''^'' ),
						'', $'', ''$'' ), '', $'', ''$'' ), '', $'', ''$'' ),
						'', ,'', '', ''), '', ,'', '', ''), '', ,'', '', ''),
						''^'', '''' ), ''$'', '''' ) as Phone
				From OPENROWSET(''' + @providername + ''',''' + @connectstring + ''', ''
					Select ' + @colid + ' as Id, ' + @colsphonebasic + '
					From ' + case when ( Len ( @table ) > 0 ) then @table else '( ' + @query + ' )a ' end + ' '' ) t 
				) a
		'

	exec sp_executesql @sql

	----------------------

	-- TEST
	--set @sql = 'Select * FROM ' + @temptable 
	--exec sp_executesql @sql

	----------------------

	Begin tran CreateIdNumCache

	----------------------


	declare @tt nvarchar ( 100 )
	set @tt = @temptable

	Select @sql = '
		Insert into ' + @tableidx + '
			Select * From ' + @tt + ' 
			Where not Phone like ''%,%'' 
				and not Phone like ''%;%''' +
				case when ( @spacesep = 1 ) then '
				and not Phone like ''% %''' else '' end + '
				and not Phone like ''''
		'

	exec sp_executesql @sql


--	set @dt1 = GetDate() - @dt
--	print 'part3     ' + cast ( DatePart ( hh, @dt1 ) as nvarchar ( 10 ) ) + ':' + cast ( DatePart ( mi, @dt1 ) as nvarchar ( 10 ) ) + ':' + cast ( DatePart ( ss, @dt1 ) as nvarchar ( 10 ) ) + ':' + cast ( DatePart ( ms, @dt1 ) as nvarchar ( 10 ) )


	Select @sql = '
		Declare @sep table ( sep nvarchar(10) collate database_default, sepindex int )
		Insert into @sep ( sep, sepindex ) Values ( '','', null )
		Insert into @sep ( sep, sepindex ) Values ( '';'', null ) ' + 
		case when ( @spacesep = 1 ) then '
		Insert into @sep ( sep, sepindex ) Values ( '' '', null ) ' else '' end + '
		
		Declare ucursor Cursor LOCAL FAST_FORWARD For 
			Select Id, Phone From ' + @tt + ' Where Phone like ''%,%'' or Phone like ''%;%''

		declare @id int, @phone nvarchar ( 1000 )

		Open ucursor
		Fetch Next From ucursor Into @id, @phone

		While ( @@fetch_status = 0 )
		   begin	
			declare @i int, @j1 int, @j2 int, 
				@j2_1 int, @j2_2 int,
				@ph nvarchar ( 50 )
	
			set @i = 0
			set @j1 = 1
			set @j2 = 0
			
			set @j2_1 = 0
			set @j2_2 = 0
			
			--set @j2_1 = charindex ( '','', @phone, @j1 ) 
			--set @j2_2 = charindex ( '';'', @phone, @j1 )
			--if (( @j2_1 < @j2_2 ) and ( @j2_1 > 0 )) or ( @j2_2 <= 0 )
			--	set @j2 = @j2_1
			--else
			--	set @j2 = @j2_2
			Update @sep 
			Set sepindex = charindex ( sep, @phone, @j1 ) 
			Select @j2 = min ( sepindex ) From @sep Where sepindex > 0
			
			while @j2 > 0 or @i = 0
			begin		
				if ( @j2 = 0 )
				begin
					set @j2 = len ( @phone ) + 1
					set @i = 1
				end
	
				select @ph = REPLACE ( REPLACE ( REPLACE ( REPLACE ( 
					LTRIM ( RTRIM ( substring ( @phone, @j1, @j2-@j1 ) ) ), 
					'' '', '''' ), ''('', '''' ), '')'', '''' ), ''-'', '''' )

				if ( Len ( @ph ) > 0 )
					if not exists ( select id from ' + @tableidx + ' where id = @id and Phone = @ph )
						Insert into ' + @tableidx + ' Values ( @id, @ph )

				select @j1 = @j2 + 1, @j2 = 0
				
				set @j2_1 = charindex ( '','', @phone, @j1 ) 
				set @j2_2 = charindex ( '';'', @phone, @j1 )
				if (( @j2_1 < @j2_2 ) and ( @j2_1 > 0 )) or ( @j2_2 <= 0 )
					set @j2 = @j2_1
				else
					set @j2 = @j2_2
			end
	
	

			Fetch Next From ucursor Into @id, @phone
		   end

		Close ucursor
		Deallocate ucursor
	'

	exec sp_executesql @sql


--	set @dt1 = GetDate() - @dt
--	print 'part4     ' + cast ( DatePart ( hh, @dt1 ) as nvarchar ( 10 ) ) + ':' + cast ( DatePart ( mi, @dt1 ) as nvarchar ( 10 ) ) + ':' + cast ( DatePart ( ss, @dt1 ) as nvarchar ( 10 ) ) + ':' + cast ( DatePart ( ms, @dt1 ) as nvarchar ( 10 ) )

	
	----------------------

	set @sql = '	
		if exists ( select * from sysobjects where id = object_id ( ''' + @temptable + ''' ) )
			drop table ' + @temptable + ' 
		
		if exists ( select * from sysobjects where id = object_id ( ''' + @temptable2 + ''' ) )
			drop table ' + @temptable2 + ' 
		'

	exec sp_executesql @sql

	----------------------

	Commit tran CreateIdNumCache

end
GO

---------------------------------------------
------- DISTR DIRECT CreateIdNumCache base
---------------------------------------------

if exists ( select * from sysobjects where id=object_id ( 'dbo.A_TaskManager_List_DistrDirectDb_IdNumCache_Create' ))
	Drop procedure dbo.A_TaskManager_List_DistrDirectDb_IdNumCache_Create
GO

Create procedure dbo.A_TaskManager_List_DistrDirectDb_IdNumCache_Create
	@taskid uniqueidentifier,
	@table nvarchar ( 100 ) = '',
	@query nvarchar ( 4000 ) = '',
	@colid nvarchar ( 100 ),
	@colsphone nvarchar ( 1000 ),
	@colsphonebasic nvarchar ( 1000 ) = ''
	
as
begin


------------------------------------------------------------

--declare @table nvarchar ( 100 )
--declare @colid nvarchar ( 100 )
--declare @taskid uniqueidentifier
--declare @colsphone nvarchar ( 1000 )
--declare @query nvarchar ( 4000 )

--Select @taskid = '2E170DDF-CFFF-4571-A058-A9DD2629D8B1', @colid = N'Id', @colsphone = N' IsNull ( [Phone], '''' ) ', @table = N'dbo.[A_TaskManager_LocalList_982b3182-d7c5-453f-8e75-af837e61eba7_0]'

----------------------------------------------------------

	declare @temptable nvarchar (100 )
	set @temptable = 'dbo.[t_cache1_' + cast ( @taskid as nvarchar (100 ) ) + ']'

	declare @temptable2 nvarchar (100 )
	set @temptable2 = 'dbo.[t_cache2_' + cast ( @taskid as nvarchar (100 ) ) + ']'

	declare @tableidx nvarchar (100), @tableidxconstr nvarchar ( 100 )
	set @tableidx = 'dbo.[A_TaskManager_dIdxn_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	set @tableidxconstr = 'A_TaskManager_dIdxn_' + cast ( @taskid as nvarchar ( 50 ) )
	


	declare @sql nvarchar ( 4000 )

	----------------------

	set @sql = '
		If not exists ( select * FROM sysobjects where id = object_id ( ''' + @tableidx + ''' ) )
			Create Table ' + @tableidx + ' ( id int not null, Phone nvarchar ( 50 ) collate database_default not null )
		'

	exec sp_executesql @sql

	set @sql = '
		if not exists ( select s.name, s.parent_obj, s1.name from sysobjects s
			inner join sysobjects s1 on s.parent_obj = s1.Id where s.name like ''PK_' + @tableidxconstr + ''' )
			ALTER TABLE ' + @tableidx + ' ADD CONSTRAINT [PK_' + @tableidxconstr + '] PRIMARY KEY CLUSTERED 
			( [Id], [Phone] )  ON [PRIMARY] 
		'
			
	exec sp_executesql @sql

	set @sql = 'Truncate table ' + @tableidx

	exec sp_executesql @sql

	----------------------
	
	begin tran CreateIdNumCache

	----------------------

	set @sql = '
	
		if exists ( select * from sysobjects where id = object_id ( ''' + @temptable + ''' ) )
			drop table ' + @temptable + ' 
		'

	exec sp_executesql @sql
	
	----------------------

	set @sql = '
	
		if exists ( select * from sysobjects where id = object_id ( ''' + @temptable2 + ''' ) )
			drop table ' + @temptable2 + ' 
		'

	exec sp_executesql @sql
	
	-----------------------

	-- Пробел разделитель?
	Declare @spacesep bit
	Select @spacesep = case when ( valueint = 1 ) then 1 else 0 end
	From A_Settings 
	Where [name] like 'us~~~~b_UseDividerSpaceInNumbers'
	
	-----------------------------------

	declare @dt datetime, @dt1 datetime
	set @dt = GetDate()

	set @sql = '
		Select ' + @colid + ' as Id,
			Replace ( Replace ( Replace (
			Replace ( Replace ( Replace ( 
			Replace ( Replace ( Replace (
			Replace ( Replace (
				''^'' + ' + @colsphone + ' + ''$'', 
				''^, '', ''^'' ), ''^, '', ''^'' ), ''^, '', ''^'' ),
				'', $'', ''$'' ), '', $'', ''$'' ), '', $'', ''$'' ),
				'', ,'', '', ''), '', ,'', '', ''), '', ,'', '', ''),
			''^'', '''' ), ''$'', '''' ) as Phone into ' + @temptable + '
		From '
	if ( Len ( @table ) > 0 )
		set @sql = @sql + @table
	else
		set @sql = @sql + '( ' + @query + ' )a'
		
	exec sp_executesql @sql

	----------------------

	-- TEST
	--set @sql = 'Select * FROM ' + @temptable 
	--exec sp_executesql @sql

	----------------------

	declare @tt nvarchar ( 100 )
	set @tt = @temptable

	Select @sql = '
		Insert into ' + @tableidx + '
			Select * From ' + @tt + ' 
			Where not Phone like ''%,%'' 
				and not Phone like ''%;%''' +
				case when ( @spacesep = 1 ) then '
				and not Phone like ''% %''' else '' end + '
				and not Phone like ''''
		'

	exec sp_executesql @sql


--	set @dt1 = GetDate() - @dt
--	print 'part3     ' + cast ( DatePart ( hh, @dt1 ) as nvarchar ( 10 ) ) + ':' + cast ( DatePart ( mi, @dt1 ) as nvarchar ( 10 ) ) + ':' + cast ( DatePart ( ss, @dt1 ) as nvarchar ( 10 ) ) + ':' + cast ( DatePart ( ms, @dt1 ) as nvarchar ( 10 ) )


	Select @sql = '
		Declare @sep table ( sep nvarchar(10) collate database_default, sepindex int )
		Insert into @sep ( sep, sepindex ) Values ( '','', null )
		Insert into @sep ( sep, sepindex ) Values ( '';'', null ) ' + 
		case when ( @spacesep = 1 ) then '
		Insert into @sep ( sep, sepindex ) Values ( '' '', null ) ' else '' end + '
		
		Declare ucursor Cursor LOCAL FAST_FORWARD For 
			Select Id, Phone From ' + @tt + ' Where Phone like ''%,%'' or Phone like ''%;%''

		declare @id int, @phone nvarchar ( 1000 )

		Open ucursor
		Fetch Next From ucursor Into @id, @phone

		While ( @@fetch_status = 0 )
		   begin	
			declare @i int, @j1 int, @j2 int, 
				@j2_1 int, @j2_2 int,
				@ph nvarchar ( 50 )
	
			set @i = 0
			set @j1 = 1
			set @j2 = 0
			
			set @j2_1 = 0
			set @j2_2 = 0
			
			--set @j2_1 = charindex ( '','', @phone, @j1 ) 
			--set @j2_2 = charindex ( '';'', @phone, @j1 )
			--if (( @j2_1 < @j2_2 ) and ( @j2_1 > 0 )) or ( @j2_2 <= 0 )
			--	set @j2 = @j2_1
			--else
			--	set @j2 = @j2_2
			Update @sep 
			Set sepindex = charindex ( sep, @phone, @j1 ) 
			Select @j2 = min ( sepindex ) From @sep Where sepindex > 0
			
			while @j2 > 0 or @i = 0
			begin		
				if ( @j2 = 0 )
				begin
					set @j2 = len ( @phone ) + 1
					set @i = 1
				end
	
				select @ph = REPLACE ( REPLACE ( REPLACE ( REPLACE ( 
					LTRIM ( RTRIM ( substring ( @phone, @j1, @j2-@j1 ) ) ), 
					'' '', '''' ), ''('', '''' ), '')'', '''' ), ''-'', '''' )

				if ( Len ( @ph ) > 0 )
					if not exists ( select id from ' + @tableidx + ' where id = @id and Phone = @ph )
						Insert into ' + @tableidx + ' Values ( @id, @ph )

				select @j1 = @j2 + 1, @j2 = 0
				
				set @j2_1 = charindex ( '','', @phone, @j1 ) 
				set @j2_2 = charindex ( '';'', @phone, @j1 )
				if (( @j2_1 < @j2_2 ) and ( @j2_1 > 0 )) or ( @j2_2 <= 0 )
					set @j2 = @j2_1
				else
					set @j2 = @j2_2
			end
	
	

			Fetch Next From ucursor Into @id, @phone
		   end

		Close ucursor
		Deallocate ucursor
	'

	exec sp_executesql @sql


--	set @dt1 = GetDate() - @dt
--	print 'part4     ' + cast ( DatePart ( hh, @dt1 ) as nvarchar ( 10 ) ) + ':' + cast ( DatePart ( mi, @dt1 ) as nvarchar ( 10 ) ) + ':' + cast ( DatePart ( ss, @dt1 ) as nvarchar ( 10 ) ) + ':' + cast ( DatePart ( ms, @dt1 ) as nvarchar ( 10 ) )

	
	----------------------

	set @sql = '	
		if exists ( select * from sysobjects where id = object_id ( ''' + @temptable + ''' ) )
			drop table ' + @temptable + ' 
		
		if exists ( select * from sysobjects where id = object_id ( ''' + @temptable2 + ''' ) )
			drop table ' + @temptable2 + ' 
		'

	exec sp_executesql @sql

	----------------------

	Commit tran CreateIdNumCache
end
GO

---------------------------------------------
------- DISTR DIRECT SearchForCall
---------------------------------------------

if exists ( select * from sysobjects where id= object_id ( 'dbo.A_TaskManager_List_DistrDirectDb_SearchForCallP' ))
	Drop procedure dbo.A_TaskManager_List_DistrDirectDb_SearchForCallP
GO

Create procedure dbo.A_TaskManager_List_DistrDirectDb_SearchForCallP
	@idoperator uniqueidentifier,
	@taskid uniqueidentifier,
	@cols nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ) = 'Id',
	@table nvarchar ( 100 ) = '',
	@query nvarchar ( 4000 ) = '',
	@search nvarchar ( 4000 ) = '',
	@states nvarchar ( 4000 ) = '',
	@dtnow datetime = NULL,
	@partindex int = 0,
	@partcount int = 1000,
	@totalrowcount int OUTPUT,
	@providername nvarchar(500) = 'SQLOLEDB',
	@connectstring nvarchar(4000) = ''	
as
begin

----------------------------------------------------------------------
/*
Declare @idoperator uniqueidentifier,
	@taskid uniqueidentifier,
	@cols nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ),
	@table nvarchar ( 100 ),
	@query nvarchar ( 4000 ),
	@search nvarchar ( 4000 ),
	@states nvarchar ( 4000 ),
	@dtnow datetime,
	@partindex int,
	@partcount int,
	@totalrowcount int,
	@providername nvarchar(500),
	@connectstring nvarchar(4000)

Select 	@idoperator = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8',
	@taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF',
	@cols = ', t.Name, t.Phone1, t.Phone2, t.dt',
	@idfield = 'Id',
	@table = '',
	@query = 'Select * From T_X Where id < 2000',
	@search = ' ( t.Name like ''%B%'' )' ,
	@states = '6:0,5:1,11:1,0:2',
	@dtnow = NULL,
	@partindex = 0,
	@partcount = 3,
	@totalrowcount = 0,
	@providername = 'SQLOLEDB',
	@connectstring = 'server=PROGRAMMER;database=oktell;uid=sa;pwd=123;'
--*/
--------------------------------------------------------------------------

	Select @search = Replace ( @search, '''', '''''' )

	if ( @dtnow is null )
		set @dtnow = GetDate()

	declare @operator nvarchar ( 100 )
	set @operator = '''' + cast ( @idoperator as nvarchar ( 100 ) ) + ''''

	declare @tableidx nvarchar ( 100 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @tableidxn nvarchar ( 100 )
	set @tableidxn = 'dbo.[A_TaskManager_dIdxn_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @tmptable nvarchar ( 100 )
	set @tmptable = 'dbo.[t_cachex_' + cast ( NewId() as nvarchar ( 100 ) ) + ']'

	declare @tmptable2 nvarchar ( 100 )
	set @tmptable2 = 'dbo.[t_cachex_' + cast ( NewId() as nvarchar ( 100 ) ) + ']'

	declare @sql nvarchar ( 4000 )

	-----------------------------------------------

	declare @callstates table ( id int, type int )
	declare @i int, @j1 int, @j2 int, @st1 nvarchar ( 100 ), @vs int, @vt int
	set @i = 0
	set @j1 = 1
	set @j2 = 0
			
	set @j2 = charindex ( ',', @states, @j1 )
	while @j2 > 0 or @i = 0
	begin		
		if ( @j2 = 0 )
		begin
			set @j2 = len ( @states ) + 1
			set @i = 1
		end
	
		select @st1 = LTRIM ( RTRIM ( substring ( @states, @j1, @j2-@j1 ) ) )
		select @vs = Cast ( SubString ( @st1, 1, charindex ( ':', @st1, 1 ) - 1 ) as int )
		set @j1 = charindex ( ':', @st1, 1 ) + 1
		select @vt = Cast ( SubString ( @st1, @j1, len ( @st1 ) - @j1 + 1 ) as int )

		Insert into @callstates values ( @vs, @vt )

		select @j1 = @j2 + 1, @j2 = 0
		set @j2 = charindex ( ',', @states, @j1 )
	end
	

	----------------------------------------------

	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#t' ) )
		Drop table #t

	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#t2' ) )
		Drop table #t2	
	
	Create table #t ( id int, Phone nvarchar ( 50 ) collate database_default )
	
	set @sql = '
		Select id2.Id, id2.Phone 
		From ' + @tableidx + ' id1 
			Inner join ' + @tableidxn + ' id2 on id1.Id = id2.Id
		Where IdOperator = ' + @operator + '
		'
	Insert into #t
		exec sp_executesql @sql



	declare @temp table ( IdInList int, AbonentNumber nvarchar ( 50 ) collate database_default, DTS DateTime  )

	Insert into @temp
		Select IdInList, AbonentNumber, Max ( DateTimeStart ) as DTS
		From #t t 
			inner join oktell_cc_temp.dbo.A_Cube_CC_EffortConnections ec on t.Id = ec.IdInList and t.Phone = ec.AbonentNumber
		Where IdTask = @taskid
		Group by IdInList, AbonentNumber


	Set @sql = 'Drop table ' + @tmptable
	if exists ( Select * FROM sysobjects where id = object_id ( @tmptable ) )
		exec sp_executesql @sql

	Set @sql = 'Drop table ' + @tmptable2
	if exists ( Select * FROM sysobjects where id = object_id ( @tmptable2 ) )
		exec sp_executesql @sql

	--Set @sql = 'Create table ' + @tmptable + ' ( Id int, '

	declare @ready table ( Id int )
	Insert into @ready
		Select IdInList
		From A_TaskManager_SubTasks
		Where TaskId = @taskid and NResult > 0

	--все несделанные из тронутых. Надо сделать, чтобы не фильтровались по состояниям. для этого
	if exists ( Select id from @callstates Where Type = 3 )
	begin
		Delete From @callstates where Type = 0 or Type = 1
		Insert into @callstates values ( 0, 10 )
	end
		

	
	--если по фильтрам смотреть надо - надо однако фильтрануть всех, кто уже сделан
	Select t.IdInList, t.AbonentNumber, ec.DateTimeStart as __DateTimeStart, ec.CallResult as __CallResult, 
		ec.UserResult as __UserResult, oi.[Name] as __Operator, 
		case when ( st.NextEffortTime > stn.NextEffortTime ) then st.NextEffortTime else stn.NextEffortTime end as __NextCallTime 
		into #t2
	From @temp t
		inner join oktell_cc_temp.dbo.A_Cube_CC_EffortConnections ec on t.IdInList = ec.IdInList and t.AbonentNumber = ec.AbonentNumber and t.DTS = ec.DateTimeStart
		inner join @callstates cs on ( ec.CallResult = cs.Id and cs.Type = 0 ) or ( ec.UserResult = cs.Id and cs.Type = 1 ) or ( cs.Type = 10 )
		
		inner join A_TaskManager_SubTaskNumber stn on t.IdInList = stn.IdInList and t.AbonentNumber = stn.Number and stn.TaskId = @taskid
		inner join A_TaskManager_SubTasks st on t.IdInList = st.IdInList and st.TaskId = @taskid
		Left join oktell_cc_temp.dbo.A_Cube_CC_Cat_OperatorInfo oi on ec.IdOperator = oi.[Id]
	Where not exists ( Select * FROM @ready where Id = t.IdInList )

	Alter table #t2 Alter Column __DateTimeStart DateTime NULL
	Alter table #t2 Alter Column __CallResult Int NULL
	Alter table #t2 Alter Column __UserResult Int NULL
	Alter table #t2 Alter Column __Operator nvarchar ( 100 ) NULL
	Alter table #t2 Alter Column __NextCallTime DateTime NULL

	Update #t2 set __NextCallTime = null where __NextCallTime < @dtnow

	--нетронутые (которых нет в кубе, и в статистике попыток задачи), нужны при выборе пунктов "нетронутые" и "несделанные"
	if exists ( Select id from @callstates Where Type = 2 or Type= 3 )
		Insert into #t2 ( IdInList, AbonentNumber )
		Select Id, Phone From #t t
			Where not exists ( Select IdInList From @temp where IdInList = t.Id and AbonentNumber = t.Phone )
				and not exists ( Select Id From @ready Where Id = t.Id )

	if ( Len ( @search ) > 0 ) begin

		-- С фильтром на данные

		-- Из самой таблицы дергаем с условием
		Set @sql = '
				if exists ( select * from tempdb..sysobjects where id=object_id(''tempdb..#tcache''))
					Drop table #tcache

				-- Сначала фильтр удаленный и выкачиваем идентификаторы

				Select t.[' + @idfield + '] as idc into #tcache
				From OPENROWSET(''' + @providername + ''',''' + @connectstring + ''', 
					''Select [' + @idfield + '] 
					From ' + case when ( Len ( @table ) > 0 ) then @table else '( ' + @query + ' ) ' end + ' t
					Where ' + @search + ' '' ) t 

				-- Потом уже пересечение для определения количества
				--   Делаем вставку в реальную таблицу, так как вывод сразу на вставку при использовании OpenRowSet валится

				Select Count ( * ) as cnt into ' + @tmptable2 + '
				From #tcache t 
					inner join #t2 t2 on t.[Idc] = t2.IdInList

				Drop table #tcache
			'
		exec sp_executesql @sql

		-- Создаем временную#, т.к. сразу в переменную нельзя записать изза динамического задания
		if exists ( Select * From tempdb..sysobjects where id = object_id ( 'tempdb..#tx' ) )
			drop table #tx
		create table #tx ( cnt int )
		-- Выдергиваем во временную#
		set @sql = 'if exists ( select * from sysobjects where id=object_id ( ''' + @tmptable2 + ''' ))
				Select cnt From ' + @tmptable2 + '
				else
				Select 0 '
				
		Insert into #tx
			exec sp_executesql @sql
		-- Удаляем динамическую
		set @sql = 'if exists ( select * from sysobjects where id=object_id ( ''' + @tmptable2 + ''' ))
				Drop table ' + @tmptable2
		exec sp_executesql @sql
		-- Забираем в переменную из временной#
		Select @totalrowcount = [cnt] From #tx

		-- Удаляем временную#
		drop table #tx

	end else begin

		-- Сразу без фильтра
		Select @totalrowcount = Count ( * ) From #t2

	end


	declare @howmany int, @topcnt int
	select @howmany = ( @partindex + 1 ) * @partcount - @totalrowcount, @topcnt = @partcount
	if ( @howmany > 0 )
		set @topcnt = @partcount - @howmany


	Set @sql = '
		Select * 
		From ( 
			Select Top ' + Cast ( @topcnt as nvarchar ( 10 ) ) + ' * 
			From ( 
				Select Top ' + Cast ( ( @partindex + 1 ) * @partcount as nvarchar ( 10 ) ) + ' t2.* ' + @cols + ' 
				From OPENROWSET(''' + @providername + ''',''' + @connectstring + ''', 
						''Select ' + @idfield + @cols + ' 
						From ' + case when ( Len ( @table ) > 0 ) then @table else '( ' + @query + ' )' end + ' t
						' + case when ( Len ( @search ) > 0 ) then 'Where ' + @search else '' end + ' '') t
					Inner Join #t2 t2 on t.[' + @idfield + '] = t2.IdInList
				Order by IdInList ) tp 
			Order By IdInList desc ) a 
		Order by IdInList
		'

	exec sp_executesql @sql	

end
GO

---------------------------------------------
------- DISTR DIRECT 
---------------------------------------------

if exists ( select * from sysobjects where id= object_id ( 'dbo.A_TaskManager_List_DistrDirectDB_P' ))
	Drop procedure dbo.A_TaskManager_List_DistrDirectDB_P
GO