﻿---------------------------------------------------------------------------
--------------- Добавление поля в таблицу W_Messages_Dialogs --------------
---------------------------------------------------------------------------
If exists ( Select * From sysobjects where id = object_id ( 'W_Messages_Dialogs' ))
  If not Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'W_Messages_Dialogs' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'fromA' )
	Alter Table dbo.W_Messages_Dialogs
	Add [fromA] int default null
GO

Update dbo.W_Messages_Dialogs 
Set fromA = null
GO

---------------------------------------------------------------------------
---------------------- Триггер W_UpdateDialogTrigger ----------------------
---------------------------------------------------------------------------
if exists ( select * FROM sysobjects where id = object_id ( 'dbo.W_UpdateDialogTrigger' ))
	Drop trigger dbo.W_UpdateDialogTrigger
GO

CREATE TRIGGER [dbo].[W_UpdateDialogTrigger] 
   ON [dbo].[A_UserMessages]
   AFTER INSERT
AS 
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;
	
	declare @message nvarchar(4000), @count int
	--@iduserA uniqueidentifier,
	--@iduserB uniqueidentifier,
	--@sentdate datetime, 
	
	
	--select 	@iduserA = iduserA,
	--@iduserB = iduserB,
	--@sentdate = sentdate
	--from inserted
	Select count ( * ) 
	From inserted i
	Where i.IsConf = 0

	if ( @@rowcount = 0 )
  	  return;
	
	select @message = substring (um.message, 0, 255)
	from A_UserMessages um, inserted i
	where um.iduserA = i.iduserA
		and um.iduserB = i.iduserB
		and um.sentdate = i.sentdate
	
	update W_Messages_Dialogs 
	set sentdate = i.sentdate, 
		lastmessage = @message,
		messagecount = md.messagecount+1,
		hasnew = 0,
		fromA = 1
	from inserted i, 
		W_Messages_Dialogs md
	where (md.iduserA = i.iduserA and md.iduserB = i.iduserB)
	
	
	
	if ((select count(*) from A_UserMessages um, inserted i where um.iduserA = i.iduserB and um.iduserB = i.iduserA and um.Viewed != 1) > 0)
	begin
		Update W_Messages_Dialogs 
		set hasnew = 1 from inserted i, W_Messages_Dialogs md where md.iduserA = i.iduserA and md.iduserB = i.iduserB and hasnew = 0
	end
	
	
	update W_Messages_Dialogs 
	set sentdate = i.sentdate, 
		lastmessage = @message,
		messagecount = md.messagecount+1,
		hasnew = 1,
		fromA = 0
	from inserted i, 
		W_Messages_Dialogs md
	where (md.iduserB = i.iduserA and md.iduserA = i.iduserB)
	
	if ( @@rowcount = 0 ) begin
	
		select @count = count (*)
		from A_UserMessages um,  inserted i
		where (um.iduserA = i.iduserA and um.iduserB = i.iduserB) or (um.iduserB = i.iduserA and um.iduserA = i.iduserB)
		
		insert into W_Messages_Dialogs (iduserA, iduserB, sentdate, messagecount, lastmessage,hasnew)--
		  select iduserA,
			iduserB,
			sentdate,
			@count,
			@message,
			0
		from inserted
		
		insert into W_Messages_Dialogs (iduserB, iduserA, sentdate, messagecount, lastmessage,hasnew)--
		  select iduserA,
			iduserB,
			sentdate,
			@count,
			@message,
			1
		from inserted
	end

END
GO

---------------------------------------------------------------------------
-------------------------------- Процедуры --------------------------------
---------------------------------------------------------------------------

if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_UserMessages_SetViewed' ))
	Drop procedure dbo.A_UserMessages_SetViewed
GO

Create procedure [dbo].[A_UserMessages_SetViewed]
	@idmessage uniqueidentifier
as
begin
	declare @ida uniqueidentifier
	declare @idb uniqueidentifier
	declare @dt datetime

	Select @ida = IdUserA, @idb = IdUserB, @dt = SentDate
	From A_UserMessages 
	Where Id = @idmessage

	if ( @@rowcount = 0 )
		return


	declare @rowcount int
	
	Update A_UserMessages
	Set Viewed = 1, ViewedDate = GetDate ( )
	Where IdUserA = @ida and IdUserB = @idb and SentDate <= @dt and Viewed != 1
	
	select @rowcount = @@rowcount
	
	if ((select count(*) from A_UserMessages where IdUserA = @ida and IdUserB = @idb and Viewed != 1) = 0)
	begin
		Update W_Messages_Dialogs 
		set hasnew = 0 where IdUserB = @ida and IdUserA = @idb and hasnew != 0
	end
	
	Select 120318, @rowcount as updatedcount
end
GO

----------

if exists ( select * FROM sysobjects where id = object_id ( 'dbo.W_Messages_GetDialogs' ))
	Drop procedure dbo.W_Messages_GetDialogs
GO

Create procedure [dbo].[W_Messages_GetDialogs]
	@iduser uniqueidentifier
	,@first int = null, @count int = null
as
begin

--declare @iduser uniqueidentifier, @first int, @count int
--select @iduser = '1654740F-0600-493B-B8FD-B09AC9A5A99C',
--@first = 1, @count  = 20
	
	select [id] = identity (int,1,1) 
			,[idUserB]
			,sentdate
			,lastmessage
			,messagecount
			,hasnew
			,fromA
	into #temp
	from W_Messages_Dialogs 
	where iduserA = @iduser
	order by sentdate desc

	if (@first is null or @count is null)
			select * 
			from #temp
			--order by sentdate desc
	else
	select * 
	from #temp
	where id between @first and @first + @count - 1
	--order by sentdate desc

	drop table #temp
	
end
GO

----------

if exists ( select * FROM sysobjects where id = object_id ( 'dbo.W_Messages_GetLastNByDate' ))
	Drop procedure dbo.W_Messages_GetLastNByDate
GO

Create procedure [dbo].[W_Messages_GetLastNByDate]
	@idusera	uniqueidentifier,
	@iduserb	uniqueidentifier,
	@startdate	datetime,
	@count		int
as
begin
	Create table #temp  ( 
		Inc	int identity (1,1),
		Id	uniqueidentifier,
		IdUserA uniqueidentifier,
		IdUserB	uniqueidentifier,
		SentDate DateTime,
		Message text collate database_default,
		Viewed bit--,ViewedDate DateTime 
		)

		Insert into #temp
		Select top 100 Id, IdUserA, IdUserB, SentDate, Message, Viewed --Top 100
		FROM A_UserMessages 
		Where (( IdUserA = @idusera And IdUserB = @iduserb )	or ( IdUserA = @iduserb And IdUserB = @idusera ))
			and SentDate < @startdate
		--Order By SentDate Desc
		
		select * 
		from #temp
		where Inc <= @count
		Order by SentDate desc
		
		
		select * from [dbo].[A_UserMessageFiles]
		where [idmessage] in (select Id 
		from #temp
		where Inc <= @count
		--Order by SentDate desc
		)
		
		drop table #temp
end
GO







