﻿if exists ( select * from sysobjects where id=object_id ( 'dbo.A_Clients_Contacts_Type_Delete' ))
	Drop procedure dbo.A_Clients_Contacts_Type_Delete
GO

Create procedure [dbo].[A_Clients_Contacts_Type_Delete]
	@id	uniqueidentifier
As
begin
	-- Если это оставить - тип контакта удаляется вместе со всеми контактами этого типа
	/*
	Delete 
	From A_ClientContacts
	Where IdContact = @id
	*/

	-- Перевод контактов существующих этого удаляемого типа в неизвестный тип (вместо удаления)
	Declare @ncid uniqueidentifier, @ncname nvarchar(500)
	Set @ncid = 'C48216D3-15A9-4E66-92FD-D92CE9EEAF99'
	
	Select @ncname = langvalue 
	From A_LangTexts
	Where langkey like 'deletedcontacttypename'
	if ( @ncname is NULL )
		Set @ncname = 'Неизвестный'
	
	Update A_ClientContactTypes
	Set Name = @ncname
	Where Id = @ncid
	if ( @@rowcount = 0 )
		Insert into A_ClientContactTypes ( Id, Name, IsPhoneNumber, web )
		Values ( @ncid, @ncname, 0, 0 )

	Update A_ClientContacts
	Set IdContact = @ncid
	Where IdContact = @id

	-- Дефолтный контактный тип для удаленных нельзя удалять, если к нему относятся данные какие нибудь
	if ( @@rowcount > 0 )
		if ( @id = @ncid )
			return;


	-- Собственно само удаление
	Delete
	From A_ClientContactTypes 
	Where [Id] = @id 
		and ( web != 1 or web is null )
end
GO

