﻿if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Clients__GetByContact' ))
	Drop procedure dbo.A_Clients__GetByContact
GO

Create procedure [dbo].[A_Clients__GetByContact]
	@contact	nvarchar ( 255 ),
	@ownerid 	uniqueidentifier,
	@id		uniqueidentifier output,
	@name		nvarchar ( 255 ) output
as
begin
	Declare @idclient uniqueidentifier
	Set @idclient = '00000000-0000-0000-0000-000000000000'

	Declare @contactlen int
	Set @contactlen = Len ( @contact )

	Select @idclient = IdClient
	From A_ClientContacts
	Where (( Len ( Content ) = @contactlen ) or (( Len ( Content ) >= 6 ) and ( @contactlen >= 6 )))
		and (( Content like '%' + @contact ) or ( @contact like '%' + Content ))
		

	if ( @@rowcount = 0 )
		return;

	Select @id = cl.[Id], @name = cl.[Name]
	From A_Clients cl
		Left join A_ClientContacts cc on cl.Id = cc.IdClient
	Where cl.Id = @idclient
		And ( cl.OwnerId = '00000000-0000-0000-0000-000000000000' Or cl.OwnerId = @ownerid )
end
GO
