﻿if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_Stat_FailedCalls' ))
Drop table dbo.A_Stat_FailedCalls
GO

if not exists ( Select * from sysobjects where id=object_id ( 'dbo.A_Stat_FailedCalls' ))
	Create table dbo.A_Stat_FailedCalls
	(
		Id uniqueidentifier,
		IdChain uniqueidentifier,
		ReasonStart int,
		ReasonFailed int,
		TimeStart DateTime,
		TimeStop DateTime,
		ALineId uniqueidentifier,
		ALineNum nvarchar(10),
		ANumberdialed nvarchar(50),
		AOutNumber nvarchar(50),
		AStr nvarchar(200),
		AUserid uniqueidentifier,
		BLineId uniqueidentifier,
		BLineNum nvarchar(10),
		--BOutNumber nvarchar(50),
		BStr nvarchar(200),
		--BUserid uniqueidentifier,
		FromCC bit
	)
GO


If exists ( Select * from dbo.sysindexes where name = N'idx_StatFailed_TStart_clstd' and id = object_id(N'[dbo].[A_Stat_FailedCalls]'))
	Drop Index [dbo].[A_Stat_FailedCalls].[idx_StatFailed_TStart_clstd]
GO


Create Clustered Index [idx_StatFailed_TStart_clstd] 
	On [dbo].[A_Stat_FailedCalls]([TimeStart]) 
	With FillFactor = 100
	ON [PRIMARY]
GO





if exists ( Select * from sysobjects where id= object_id ( 'dbo.A_Stat_FailedCall_Add' ))
	Drop procedure dbo.A_Stat_FailedCall_Add
GO

Create procedure dbo.A_Stat_FailedCall_Add	
	@idchain uniqueidentifier,
	@reasonstart int,
	@reasonfailed int,
	@timestart DateTime,
	@timestop DateTime,
	@alineid uniqueidentifier,
	@alinenum nvarchar(10),
	@anumberdialed nvarchar(50),
	@aoutnumber nvarchar(50),
	@astr nvarchar(200),
	@auserid uniqueidentifier,
	@blineid uniqueidentifier,
	@blinenum nvarchar(10),
	--@boutnumber nvarchar(50),
	@bstr nvarchar(200) = '',
	--@buserid uniqueidentifier,
	@fromccinput bit,
	@optimizedblevel int
as
Begin

	Insert into A_Stat_FailedCalls 
	( 
		Id,
		IdChain, 
		ReasonStart,
		ReasonFailed,
		TimeStart,
		TimeStop,
		ALineId,
		ALineNum,
		ANumberdialed,
		AOutNumber,
		AStr,
		AUserid,
		BLineId,
		BLineNum,
		--BOutNumber,
		BStr,
		--BUserid,
		FromCC
 	)
	Values
	( 
		NEWID(),
		@idchain,
		@reasonstart,
		@reasonfailed,
		@timestart,
		@timestop,
		@alineid,
		@alinenum,
		@anumberdialed,
		@aoutnumber,
		@astr,
		@auserid,
		@blineid,
		@blinenum,
		--@boutnumber,
		@bstr,
		--@buserid,
		@fromccinput
	)
End
GO
