﻿
if exists ( Select * from oktell_settings..sysobjects where id=object_id ('oktell_settings.dbo.A_PaidNumbers' ))
 	Drop table oktell_settings.dbo.A_PaidNumbers
GO

Create table oktell_settings.dbo.A_PaidNumbers
(
	[id] int identity (1,1) primary key, 
	[number] nvarchar(50) collate database_default
)
GO

use oktell_settings
if exists (select * from dbo.sysindexes where name = N'idx_PaidNumber' and id = object_id(N'oktell_settings.[dbo].[A_PaidNumbers]'))
drop index [dbo].[A_PaidNumbers].[idx_PaidNumber]
GO

use oktell_settings
CREATE INDEX [idx_PaidNumber] ON oktell_settings.[dbo].[A_PaidNumbers]([number]) WITH FILLFACTOR = 80 ON [PRIMARY]
GO

use oktell
GO

if exists ( Select * from sysobjects where id=object_id ('dbo.A_PaidNumbers' ) and OBJECTPROPERTY(id, N'IsView') = 1)
 	Drop view dbo.A_PaidNumbers
GO

Create VIEW dbo.A_PaidNumbers
As
	Select *
	FROM oktell_settings.dbo.A_PaidNumbers
GO


if exists ( Select * from sysobjects where id= object_id('dbo.A_PaidNumbers_GetAll'))
	Drop procedure dbo.A_PaidNumbers_GetAll
GO

Create procedure dbo.A_PaidNumbers_GetAll
as
Begin
	Select number
	From A_PaidNumbers
End
GO


if exists ( Select * from sysobjects where id= object_id('dbo.A_PaidNumbers_Search'))
	Drop procedure dbo.A_PaidNumbers_Search
GO

Create procedure dbo.A_PaidNumbers_Search
	@number nvarchar(50),
	@numberstarts nvarchar(50) = ''
as
Begin
	Select id, number
	From A_PaidNumbers
	Where ( number like @number ) 
		or (( @numberstarts != '' ) and ( number like @numberstarts + '%' ))
End
GO


Insert into dbo.A_PaidNumbers ( number ) Values ( '7809xxxxxxx' )
Insert into dbo.A_PaidNumbers ( number ) Values ( '8809xxxxxxx' )
Insert into dbo.A_PaidNumbers ( number ) Values ( '+7809xxxxxxx' )
GO