﻿if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Admin_OfficeMap_ServerGate_Get' ))
	Drop procedure dbo.A_Admin_OfficeMap_ServerGate_Get
GO

Create procedure dbo.A_Admin_OfficeMap_ServerGate_Get	
	@idserver uniqueidentifier = '00000000-0000-0000-0000-000000000000'
as
begin
	if ( @idserver = '00000000-0000-0000-0000-000000000000' )
		Select sg.Id, sg.Name, sg.IdServer, sg.RegType
		From A_ServerGates sg
	else
		Select sg.Id, sg.Name, sg.IdServer, sg.RegType
		From A_ServerGates sg
		Where sg.IdServer = @idserver
end
GO

if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Admin_OfficeMap_ServerStream_Get' ))
	Drop procedure dbo.A_Admin_OfficeMap_ServerStream_Get
GO

Create procedure dbo.A_Admin_OfficeMap_ServerStream_Get
	@idserver uniqueidentifier = '00000000-0000-0000-0000-000000000000'
as
begin
	if ( @idserver = '00000000-0000-0000-0000-000000000000' )
		Select Id, Name, IdServer, Type, Account, RegType, GateId, DialMode
		From A_ServerStreams	
		Order By Name
	else
		Select Id, Name, IdServer, Type, Account, RegType, GateId, DialMode
		From A_ServerStreams
		Where IdServer = @idserver
		Order By Name
end
GO



If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_ServerExtLines' ))
    If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_ServerExtLines' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'IsDynamicConfig' )
	Alter Table oktell_settings.dbo.A_ServerExtLines
	Add [IsDynamicConfig] bit default 0
GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ServerExtLines]') and OBJECTPROPERTY(id, N'IsView') = 1)
	drop view [dbo].[A_ServerExtLines]
GO


Create VIEW dbo.A_ServerExtLines
As
	Select *
	FROM oktell_settings.dbo.A_ServerExtLines
GO


Update dbo.A_ServerExtLines
Set IsDynamicConfig = 0
Where IsDynamicConfig is NULL
GO




If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_ServerGates' ))
    If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_ServerGates' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'IsDynamicConfig' )
	Alter Table oktell_settings.dbo.A_ServerGates
	Add [IsDynamicConfig] bit default 0
GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ServerGates]') and OBJECTPROPERTY(id, N'IsView') = 1)
	drop view [dbo].[A_ServerGates]
GO


Create VIEW dbo.A_ServerGates
As
	Select *
	FROM oktell_settings.dbo.A_ServerGates
GO


Update dbo.A_ServerGates
Set IsDynamicConfig = 0
Where IsDynamicConfig is NULL
GO




If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_ServerStreams' ))
    If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_ServerStreams' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'IsDynamicConfig' )
	Alter Table oktell_settings.dbo.A_ServerStreams
	Add [IsDynamicConfig] bit default 0
GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ServerStreams]') and OBJECTPROPERTY(id, N'IsView') = 1)
	drop view [dbo].[A_ServerStreams]
GO


Create VIEW dbo.A_ServerStreams
As
	Select *
	FROM oktell_settings.dbo.A_ServerStreams
GO


Update dbo.A_ServerStreams
Set IsDynamicConfig = 0
Where IsDynamicConfig is NULL
GO





If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_CallRoutes' ))
    If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_CallRoutes' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'IsDynamicConfig' )
	Alter Table oktell_settings.dbo.A_CallRoutes
	Add [IsDynamicConfig] bit default 0
GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ServerStreams]') and OBJECTPROPERTY(id, N'IsView') = 1)
	drop view [dbo].[A_CallRoutes]
GO


Create VIEW dbo.A_CallRoutes
As
	Select *
	FROM oktell_settings.dbo.A_CallRoutes
GO


Update dbo.A_CallRoutes
Set IsDynamicConfig = 0
Where IsDynamicConfig is NULL
GO



if exists ( select * from sysobjects where id = object_id ( 'dbo.A_DB_RemoveTails' ))
	Drop procedure dbo.A_DB_RemoveTails
GO

Create Procedure [dbo].[A_DB_RemoveTails] 
as
begin

-- Отрубание глюков после изменений в БД. Лишние ссылки, пустые элементы и т.д.

		-----------------------------------------------------
		-- динамические объекты карты сети ------------------
		-----------------------------------------------------
		Delete FROM A_ServerExtLines Where IsDynamicConfig = 1
		Delete FROM A_ServerGates Where IsDynamicConfig = 1
		Delete FROM A_ServerStreams Where IsDynamicConfig = 1
		Delete FROM A_CallRoutes Where IsDynamicConfig = 1

		-----------------------------------------------------
		-- общие возможные глюки ----------------------------
		-----------------------------------------------------
		Delete From A_WorkPlaces where (type in (2,3,4,6)) and not (parentId in (Select [ID] From A_WorkPlaces))
		Delete From A_WorkPlaces where (type in (2,3,4,6)) and not ( LineId in ( Select [ID] From A_View_ServerIntLinesAll ))
		Delete From A_ServerExtLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerIntLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerGSMLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerUSBLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerSipLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerUSBLines where not [id] in (Select LineID From A_WORKPLACES)
		Delete From A_ServerVirtualLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		
		Delete From A_LinesReactors where not [WPID] in ( Select [id] From A_WORKPLACES )
		Delete From A_LinesReactors where not LineID in ( Select [ID] From A_View_ServerLinesAll )
		Delete From A_ServerNumbers where not [id] in ( Select [ID] From A_WorkPlaces Where type=5 )
		Delete From A_ServerNumbers where [id] in ( Select [ID] From A_WorkPlaces where hasdatabase>0 )

		Delete From A_CallRoutes_Lines where not [idroute] in ( Select [ID] From A_CallRoutes )

		Declare @t table(id_ uniqueidentifier)
		insert into @t
			Select [id] From A_WORKPLACES Union 
			Select [id] From A_Users union
			Select [id] From A_ExtNumbers union
			Select [id] From A_View_ServerLinesAll			

		
		Delete From A_RuleRecords where not RuleID in (Select ID From A_Rules)

		--записи правил, где пользователь или линия несуществующие
		Delete From A_RuleRecords where (InnerAddressType in (0,1)) and ( not ReactID in (Select id_ From @t ))
		--записи правил, где поток несуществующий
		Delete From A_RuleRecords where (InnerAddressType in (3)) and ( not ReactID in (Select [Id] From A_ServerStreams ))

		Delete From A_NumberPlanAction where numtype=0 and extraid not in (Select ID From A_Rules)
		Delete From A_NumberPlan where id not in (Select numid From A_NumberPlanAction)
		Delete From A_RuleRecords where InnerAddressType=2 and not ReactID in (Select ID From A_NumberPlan)
		Delete From A_Rules	Where not id in ( Select ruleid From A_RuleRecords )		

		Delete From A_TaskManager_TaskExtLines where not ExtLineId in ( Select id From A_ServerExtLines )
		Delete From A_TaskManager_Operators where not OperatorId in ( Select id From A_Users u inner join A_UserParams up on u.Id = up.IdUser Where up.IsOperator = 1 Union Select Id From C_Groups )
		Delete From A_TaskManager_TaskProperties where not IdTask in ( Select id From A_TaskManager_Tasks )

		-----------------------------------------------------
		-- сетевые адреса рабочих мест = адресу сервера - заменяем брехней 
		-----------------------------------------------------
		Declare @svraddr nvarchar ( 100 )
		Select @svraddr = Address 
		From A_WorkPlaces
		Where HasFastEngine = 1
		Update A_WorkPlaces Set Address = 'Ошибка в адресе' 
		Where Address like @svraddr and HasFastEngine = 0

		-----------------------------------------------------
		-- Null в 0 в ID юзеров по умолчанию ----------------
		-----------------------------------------------------
		Update A_ServerIntLines
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		Update A_ServerSipLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		Update A_ServerVirtualLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		-----------------------------------------------------
		-- в 0 несуществующих юзеров по умолчанию -----------
		-----------------------------------------------------
		Update A_ServerIntLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id From A_Users)

		Update A_ServerSipLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id From A_Users)

		Update A_ServerVirtualLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id From A_Users)

		-----------------------------------------------------
		-- двоение юзеров по умолчанию в ссылках по линиям --
		-----------------------------------------------------
		Declare @useddefusers table (id uniqueidentifier)
		Declare @idtozero table (id uniqueidentifier)
		Declare @lid uniqueidentifier
		Declare @uid uniqueidentifier
		Declare @tmp bit 		

		Declare defusercur Cursor For
			Select Id, DefaultUserId 
			From A_View_ServerIntLinesDefaultUsers
			Where DefaultUserId != '00000000-0000-0000-0000-000000000000'

		Open defusercur
		Fetch Next From defusercur Into @lid, @uid
		While @@FETCH_STATUS = 0
		Begin		
			Select @tmp = 1 From @useddefusers where id = @uid
			if ( @tmp > 0 )
				Insert Into @idtozero (id) values (@lid)
			else
				Insert Into @useddefusers (id) values (@uid)
			Fetch Next From defusercur  Into @lid, @uid
		End
		Close defusercur
		Deallocate defusercur
		
		Update A_ServerIntLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerIntLines si, @idtozero iz
		Where si.Id = iz.Id

		Update A_ServerSipLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerSipLines si, @idtozero iz
		Where si.Id = iz.Id

		Update A_ServerVirtualLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerVirtualLines si, @idtozero iz
		Where si.Id = iz.Id
		
		-----------------------------------------------------
		-- удаляем несуществующие значения ------------------
		-----------------------------------------------------
		Begin Tran UIT

		Delete From A_TaskManager_UserInTask with ( TabLock, HoldLock )
		Where not exists ( Select Id From A_Users Where A_Users.Id = UserId )

		Delete From A_TaskManager_UserInTask --with ( TabLock )
		Where not exists ( Select Id From A_TaskManager_Tasks Where A_TaskManager_Tasks.Id = TaskId )
		
		Commit tran UIT


		Delete From A_TaskManager_Operators
		Where not exists ( Select Id From A_TaskManager_Tasks where A_TaskManager_Tasks.Id = TaskId )

		Delete From A_TaskManager_TaskExtLines
		Where not exists ( Select Id From A_TaskManager_Tasks where A_TaskManager_Tasks.Id = TaskId )

		Delete From A_TaskManager_Operators
		Where IsGroup = 1 and not exists ( Select Id From C_Groups where C_Groups.Id = OperatorId )

		Delete From A_TaskManager_Operators
		Where IsGroup = 1 and not Exists ( Select * From A_Users where A_Users.Id = OperatorId )
		

		Declare @uidt table ( id uniqueidentifier )
		Insert into @uidt
			Select Id From A_Users
		Delete From A_UserControls
		Where not UserA in (Select id From @uidt)
			or not UserB in (Select id From @uidt)

		-----------------------------------------------------
		-- Редиректы на удаленных юзеров --------------------
		-----------------------------------------------------
		Delete 
		From A_Redirect
		Where IdUser not in ( Select Id From A_Users )

		-----------------------------------------------------
		-- Пустые группы, номера, несвязанные правила -------
		-----------------------------------------------------
		exec A_Admin_UserGroup_Group_SiftEmpty		

		exec A_Admin_Number_SiftByActions
		
		exec A_Admin_Rule_SiftByNumbers
		
		-----------------------------------------------------
		-- неиспользуемые плагин-модули ---------------------
		-----------------------------------------------------
		Delete From A_PluginMenu_User
		Where not exists ( Select Id From A_Users u Where u.Id = A_PluginMenu_User.IdUser )

		-----------------------------------------------------
		-- канонические адреса ------------------------------
		-----------------------------------------------------	
		Delete from A_WorkPlace_Address

end
GO




if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_DynamicConfig_Add_Gate' ))
	Drop procedure dbo.A_DynamicConfig_Add_Gate
GO

Create procedure dbo.A_DynamicConfig_Add_Gate
	@gateid uniqueidentifier,
	@gatename nvarchar(200),
	@regtype int,
	@serverid uniqueidentifier = '00000000-0000-0000-0000-000000000000'
as
Begin
	Declare @srvid uniqueidentifier
	Set @srvid = @serverid
	if ( @srvid = '00000000-0000-0000-0000-000000000000' )
		Select @srvid = [Id] 
		From A_WorkPlaces 
		Where ( hasfastengine = 1 ) and ( ParentID = '00000000-0000-0000-0000-000000000000' )	

	Insert into A_ServerGates ( Id, Name, IdServer, RegType, IsDynamicConfig )
	Values ( @gateid, @gatename, @srvid, @regtype, 1 )
End
GO


if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_DynamicConfig_Add_Stream' ))
	Drop procedure dbo.A_DynamicConfig_Add_Stream
GO

Create procedure dbo.A_DynamicConfig_Add_Stream
 	@streamid uniqueidentifier,
	@streamname nvarchar(200),
	@streamtype int,
	@streamaccount nvarchar(200) = '',
	@regtype int,
	@gateid uniqueidentifier,
	@dialmode int = 0,
	@serverid uniqueidentifier = '00000000-0000-0000-0000-000000000000'
as
Begin
	Declare @srvid uniqueidentifier
	Set @srvid = @serverid
	if ( @srvid = '00000000-0000-0000-0000-000000000000' )
		Select @srvid = [Id] 
		From A_WorkPlaces 
		Where ( hasfastengine = 1 ) and ( ParentID = '00000000-0000-0000-0000-000000000000' )

	Insert into A_ServerStreams ( Id, Name, IdServer, Type, Account, RegType, GateId, DialMode, IsDynamicConfig )
	Values ( @streamid, @streamname, @srvid, @streamtype, @streamaccount, @regtype, @gateid, @dialmode, 1 )
End
GO


if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_DynamicConfig_Add_ExtLine' ))
	Drop procedure dbo.A_DynamicConfig_Add_ExtLine
GO

Create procedure dbo.A_DynamicConfig_Add_ExtLine
	@lineid uniqueidentifier,
	@type int = 7,
	@caption nvarchar(200) = '',	
	@linenum int,
	@streamid uniqueidentifier,
	@linecode nvarchar(200) = '',
	@serverid uniqueidentifier = '00000000-0000-0000-0000-000000000000'
as
Begin
	Declare @srvid uniqueidentifier
	Set @srvid = @serverid
	if ( @srvid = '00000000-0000-0000-0000-000000000000' )
		Select @srvid = [Id] 
		From A_WorkPlaces 
		Where ( hasfastengine = 1 ) and ( ParentID = '00000000-0000-0000-0000-000000000000' )

	Insert into A_ServerExtLines ( Id, ServerId, Caption, Type, DialType, CanSimpleOut, CanIP, CanAutoDial, Prefix, SystemNum, Enabled, CanMobile, ExtNumber, ConnectedPBX, StreamId, LineCode, IsDynamicConfig )
	Values ( @lineid, @srvid, @caption, @type, 0, 1, 1, 1, '', @linenum, 1, 1, '', 0, @streamid, @linecode, 1)
End
GO


if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_DynamicConfig_Add_CallRoute' ))
	Drop procedure dbo.A_DynamicConfig_Add_CallRoute
GO

Create procedure dbo.A_DynamicConfig_Add_CallRoute
	@routeid uniqueidentifier,
	@routename nvarchar(200),
	@routedescription nvarchar(200) = '',
	@routecommand nvarchar(200) = '',
	@isexternal bit = 1,
	@routetype int = 0,
	@routecode nvarchar(200) = ''
as
Begin
	Insert into A_CallRoutes ( Id, Name, Description, Command, IsExternal, Enabled, Type, Code, IsDynamicConfig )
	Values ( @routeid, @routename, @routedescription, @routecommand, @isexternal, 1, @routetype, @routecode, 1 )
End
GO


if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_DynamicConfig_Add_CallRouteLink' ))
	Drop procedure dbo.A_DynamicConfig_Add_CallRouteLink
GO

Create procedure dbo.A_DynamicConfig_Add_CallRouteLink
	@routeid uniqueidentifier,
	@lineid uniqueidentifier,
	@index int = 1
as
Begin
	Insert into A_CallRoutes_Lines ( IdRoute, IdLine, Pos )
	Values ( @routeid, @lineid, @index )
End
GO



if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_DynamicConfig_Remove_CallRoute' ))
	Drop procedure dbo.A_DynamicConfig_Remove_CallRoute
GO

Create procedure dbo.A_DynamicConfig_Remove_CallRoute
	@routeid uniqueidentifier
as
Begin
	Delete From A_CallRoutes 
	Where Id = @routeid

	Delete From A_CallRoutes_Lines
	Where IdRoute = @routeid
End
GO


if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_DynamicConfig_Remove_ExtLine' ))
	Drop procedure dbo.A_DynamicConfig_Remove_ExtLine
GO

Create procedure dbo.A_DynamicConfig_Remove_ExtLine
	@lineid uniqueidentifier
as
Begin
	Delete From A_ServerExtLines 
	Where Id = @lineid 

	Delete From A_CallRoutes_Lines
	Where IdLine = @lineid
End
GO


if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_DynamicConfig_Remove_Stream' ))
	Drop procedure dbo.A_DynamicConfig_Remove_Stream
GO

Create procedure dbo.A_DynamicConfig_Remove_Stream
 	@streamid uniqueidentifier
as
Begin
	Delete From A_ServerStreams 
	Where Id = @streamid


	Declare @lines table ( [id] uniqueidentifier )
	Insert into @lines ( [id] )
	    Select [Id]
	    From A_ServerExtLines
	    Where StreamId = @streamid

	Delete From A_ServerExtLines 
	Where StreamId = @streamid


	Declare @routes table ( [id] uniqueidentifier )
	Insert into @routes ( [id] )
	    Select Distinct IdRoute
	    From A_CallRoutes_Lines
	    Where IdLine in ( Select [id] from @lines )

	Delete From A_CallRoutes_Lines
	Where IdLine in ( Select [id] from @lines )
	

	Delete From A_CallRoutes
	Where [Id] in ( Select [id] from @routes )
		And not [Id] in ( Select Distinct IdRoute From A_CallRoutes_Lines )
End
GO


if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_DynamicConfig_Remove_Gate' ))
	Drop procedure dbo.A_DynamicConfig_Remove_Gate
GO

Create procedure dbo.A_DynamicConfig_Remove_Gate
	@gateid uniqueidentifier
as
Begin
	Delete From A_ServerGates
	Where Id = @gateid


	Declare @streams table ( [id] uniqueidentifier )
	Insert into @streams ( [id] )
	    Select [Id]
	    From A_ServerStreams
	    Where GateId = @gateid

	Delete From A_ServerStreams 
	Where GateId = @gateid


	Declare @lines table ( [id] uniqueidentifier )
	Insert into @lines ( [id] )
	    Select [Id]
	    From A_ServerExtLines
	    Where StreamId in ( Select [id] From @streams )

	Delete From A_ServerExtLines
	Where StreamId in ( Select [id] From @streams )


	Declare @routes table ( [id] uniqueidentifier )
	Insert into @routes ( [id] )
	    Select Distinct IdRoute
	    From A_CallRoutes_Lines
	    Where IdLine in ( Select [id] from @lines )

	Delete From A_CallRoutes_Lines
	Where IdLine in ( Select [id] from @lines )
	

	Delete From A_CallRoutes
	Where [Id] in ( Select [id] from @routes )
		And not [Id] in ( Select Distinct IdRoute From A_CallRoutes_Lines )
End
GO


if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_DynamicConfig_Modify_Gate' ))
	Drop procedure dbo.A_DynamicConfig_Modify_Gate
GO

Create procedure dbo.A_DynamicConfig_Modify_Gate
	@gateid uniqueidentifier,
	@gatename nvarchar(200) = NULL
as
Begin
	if ( @gatename is not NULL )
	    Update A_ServerGates
	    Set Name = @gatename
	    Where Id = @gateid
End
GO



if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_DynamicConfig_Modify_Stream' ))
	Drop procedure dbo.A_DynamicConfig_Modify_Stream
GO

Create procedure dbo.A_DynamicConfig_Modify_Stream
	@streamid uniqueidentifier,
	@streamname nvarchar(200) = NULL,
	@streamaccount nvarchar(200) = NULL
as
Begin	
	if ( @streamname is not null )
	    Update A_ServerStreams
	    Set Name = @streamname
	    Where Id = @streamid

	if ( @streamaccount is not null )
	    Update A_ServerStreams
	    Set Account = @streamaccount
	    Where Id = @streamid
End
GO



if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_Line_GetMaxExtLineNumberSip' ))
	Drop procedure dbo.A_Line_GetMaxExtLineNumberSip
GO

Create procedure dbo.A_Line_GetMaxExtLineNumberSip
	@serverid uniqueidentifier = '00000000-0000-0000-0000-000000000000'
as
Begin
	
	Declare @number int
	Set @number = 13000

	Select @number = Max ( SystemNum ) 
	From A_ServerExtLines 
	Where ( SystemNum / 1000 % 10 = 3 )
		And (( ServerId = @serverid ) or ( @serverid = '00000000-0000-0000-0000-000000000000' ))

	Select @number
End
GO



if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_Line_GetFreeExtLineNumberSipFrom' ))
	Drop procedure dbo.A_Line_GetFreeExtLineNumberSipFrom
GO

Create procedure dbo.A_Line_GetFreeExtLineNumberSipFrom
	@serverid uniqueidentifier = '00000000-0000-0000-0000-000000000000',
	@from int = 0
as
Begin
	Declare @number int
	Set @number = 13000

	Select @number = Min ( SystemNum ) 
	From A_ServerExtLines 
	Where ( SystemNum / 1000 % 10 = 3 ) 
		And (( ServerId = @serverid ) or ( @serverid = '00000000-0000-0000-0000-000000000000' ))

	Declare @x table (num int)

	if ( @from > 1000 )
		Set @from = @from % 1000

	while ( @from < 999 ) begin

		set @from = @from + 1
		set @number = @number / 1000 * 1000 + @from

		Insert into @x (num)		
		Values ( @number )
	end

	Select Min ( num ) as EmptyNum
	From @x x
	Where not exists ( Select SystemNum From A_ServerExtLines where x.Num = SystemNum)

End
GO




