﻿if exists ( Select * From sysobjects where id=object_id ( 'dbo.A_TaskManager_TaskOut_UpdateResult_Point' ))
	Drop procedure dbo.A_TaskManager_TaskOut_UpdateResult_Point
GO

Create Procedure [dbo].[A_TaskManager_TaskOut_UpdateResult_Point]
	@idtask			uniqueidentifier,	
	@idinlist		int,
	@nextefforttime	datetime,
	@nresult		int,
	@retrynumbers	nvarchar(200) = NULL
as
begin	
	--Begin tran AAA

	if ( @retrynumbers is NULL ) begin

		Update A_TaskManager_SubTasks --With ( TabLock, HoldLock )
		Set
			NextEffortTime  = @nextefforttime,
			NResult			= @nresult
		Where 
			TaskId = @idtask
			and IdInList = @idinlist

	end else begin

		Update A_TaskManager_SubTasks --With ( TabLock, HoldLock )
		Set
			NextEffortTime  = @nextefforttime,
			NResult			= @nresult,
			RetryNumbers	= @retrynumbers
		Where 
			TaskId = @idtask
			and IdInList = @idinlist

	end 

	if ( @@rowcount = 0 )
		Insert Into A_TaskManager_SubTasks --With ( TabLock )
			( IdInList, TaskId, NResult, IsDeleted, NextEffortTime, RetryNumbers )
		Values
			( @idinlist, @idtask, @nresult, 0, @nextefforttime, @retrynumbers )

	--Commit Tran AAA
end
GO