﻿
----------------------------------------------------
If exists ( Select * From sysobjects where id = object_id ( 'A_Chat_Members' ))
	If not Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_Chat_Members' 
							and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'IdAddedUser' )
	Alter Table dbo.A_Chat_Members
	Add [IdAddedUser] uniqueidentifier

GO


Update m
Set m.IdAddedUser = d.God
From A_Chat_Members m,
	A_Chat_Dialog d
Where ( m.IdDialog = d.IdDialog )
	and ( m.IdAddedUser is NULL )
GO

----------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Chat_Members_Get' ))
	Drop procedure dbo.A_Chat_Members_Get
GO

----------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Chat_Members_Add' ))
	Drop procedure dbo.A_Chat_Members_Add
GO

Create procedure [dbo].[A_Chat_Members_Add]
	@dialogid	uniqueidentifier,
	@member	uniqueidentifier,
	@addeduserid uniqueidentifier = '00000000-0000-0000-0000-000000000000'	
as
begin
		-- Добавляет указанного участника в чат

		Insert into dbo.[A_Chat_Members] ( IdDialog, IdUser, IdAddedUser )
		Values ( @dialogid, @member, @addeduserid )		

end
GO


----------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Chat_Dialog_Get' ))
	Drop procedure dbo.A_Chat_Dialog_Get
GO

Create procedure [dbo].[A_Chat_Dialog_Get]
	@dialogid	uniqueidentifier
as
begin
		-- Возвращает серверную инфу по конкретному чату
	
		-- Выборка 1 (данные чата)
		Select	dlg.IdDialog,
				dlg.Type,
				dlg.Name,
				dlg.LastIdMessage,
				dlg.LastDateUTC,
				dlg.IdLinkedObject,
				dlg.God
		From dbo.[A_Chat_Dialog] dlg
		Where dlg.IdDialog = @dialogid

		-- Выборка 2 (участники)
		Select m.IdDialog, m.IdUser, m.IdAddedUser 
		From dbo.A_Chat_Members m 
		Where m.IdDialog = @dialogid
end
GO


----------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Chat_Dialogs_GetTop' ))
	Drop procedure dbo.A_Chat_Dialogs_GetTop
GO

Create procedure [dbo].[A_Chat_Dialogs_GetTop]
	@countsec int,
	@dateutc datetime = null
as
begin
		-- Возвращает список горячих чатов для сервера по дате последнего сообщения, находящейся в некотором интервале.
		
		-- Определяем интервал и чаты попадающие в него

		if (@dateutc is null) 
			set @dateutc = getutcdate()

		Declare @datefrom datetime
		Set @datefrom = DateAdd ( second, -@countsec, @dateutc )

		Declare @t table ( id uniqueidentifier )
		
		Insert into @t
			Select	dlg.IdDialog
			From [dbo].[A_Chat_Dialog] dlg
			Where dlg.LastDateUTC >= @datefrom


		-- Выборка 1 (чаты)		
		
		Select	dlg.IdDialog,
				dlg.Type,
				dlg.Name,
				dlg.LastIdMessage,
				dlg.LastDateUTC,
				dlg.IdLinkedObject,
				dlg.God
		from [dbo].[A_Chat_Dialog] dlg
				inner join @t t on t.id = dlg.IdDialog

		-- Выборка 2 (участники)

		Select m.IdDialog, m.IdUser, m.IdAddedUser
		From A_Chat_Members m 
			inner join @t t on t.Id = m.IdDialog
		Order by m.IdDialog
		
end
GO