﻿

If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_SessionStorage' ))
  If not Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_SessionStorage' 
								and TABLE_CATALOG like 'oktell'
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME in ('Tag') )
	Alter Table [dbo].[A_SessionStorage]
	Add
		[tag] nvarchar(1000) default ''
GO


Update [dbo].[A_SessionStorage]
Set tag = ''
GO


if exists ( select * from sysobjects where id = object_id ( 'dbo.A_SessionStorage_Save' ))
	Drop procedure dbo.A_SessionStorage_Save
GO

Create procedure [dbo].[A_SessionStorage_Save]
	@dbid int,
	@storeid nvarchar(100),
	@storeinterval int,
	@storedt datetime,
	@userid uniqueidentifier,
	@remoteip nvarchar(50) = NULL,
	@tag nvarchar(1000) = NULL
as
begin

	Update A_SessionStorage
	Set storeinterval = @storeinterval,
		storedt = @storedt,
		userid = @userid,
		remoteip = @remoteip,
		tag = @tag
	Where (storageid = @dbid)
		And (storeid = @storeid)
	
	if ( @@rowcount = 0 ) begin
	
		Insert into A_SessionStorage ( storageid, storeid, storeinterval, storedt, userid, remoteip, tag )
		Values ( @dbid, @storeid, @storeinterval, @storedt, @userid, @remoteip, @tag )
		
	end
	
end
GO



if exists ( select * from sysobjects where id = object_id ( 'dbo.A_SessionStorage_GetAll' ))
	Drop procedure dbo.A_SessionStorage_GetAll
GO

Create procedure [dbo].[A_SessionStorage_GetAll]
	@dbid int,
	@dtnow datetime = NULL
as
begin
	
	if ( @dtnow is NULL )
		Set @dtnow = GetDate()
	
	Select storeid, storeinterval, storedt, userid, remoteip, tag
	From A_SessionStorage
	Where (storageid = @dbid)
		And (DateAdd ( ms, storeinterval, storedt ) > @dtnow)
		
end
GO

