﻿

-------------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_Modules_ObjectTypes_Create' ))
	Drop procedure dbo.A_Policy_Modules_ObjectTypes_Create
GO	

Create procedure dbo.A_Policy_Modules_ObjectTypes_Create
	@moduleobjectname nvarchar(500)
as	
begin
	-- Создает тип объекта (внешний к Oktell) для правовой политики доступа

	Declare @id int
	Set @id = 500
	Select @id = IsNull ( max ( id ) + 1, @id )
	From dbo.A_Policy_ObjectTypes	
	Where id >= 500
	
	Insert into dbo.A_Policy_ObjectTypes ( id, name, isBasicType )
	Values ( @id, @moduleobjectname, 0 )
	
	Select @id as id
	
end
GO

-------------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_Modules_ObjectTypes_Remove' ))
	Drop procedure dbo.A_Policy_Modules_ObjectTypes_Remove
GO	

Create procedure dbo.A_Policy_Modules_ObjectTypes_Remove
	@moduleobjectname nvarchar(500)
as	
begin

	-- Удаляет тип объекта (внешний к Oktell) для правовой политики доступа

	-- Что за тип по коду
	Declare @id int
	Select @id = id
	From dbo.A_Policy_ObjectTypes	
	Where (name like @moduleobjectname)
		and (isBasicType = 0)
		
	if ( @id is NULL )
		return @id

	-- Из типов 
	Delete 
	From dbo.A_Policy_ObjectTypes
	Where id = @id
			
	-- Из объектов
	Delete 
	From dbo.A_Policy_Objects
	Where type = @id
	
	-- Из привилегий
	Delete 
	From dbo.A_Policy_Privileges
	Where objType = @id
	
	-- Из дефолтных назначений привилегий
	Delete 
	From dbo.A_Policy_PrivilegeDefaults
	Where not exists ( select id From dbo.A_Policy_Privileges p Where p.id = dbo.A_Policy_PrivilegeDefaults.idPrivilege )
	
	-- Из выставленных субъектам привилегий
	Delete
	From dbo.A_Policy_SubjectPrivileges
	Where not exists ( select id From dbo.A_Policy_Objects o Where o.id = dbo.A_Policy_SubjectPrivileges.idObject )
	
		
	-- ид типа на выход
	Select @id as id
		
end
GO

