﻿
----------------------------------------------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Users_GetAllInGS' ))
	Drop procedure dbo.A_Users_GetAllInGS
GO

Create procedure dbo.A_Users_GetAllInGS
as
begin

	Select ID, Name 
	From A_Users 
	Where ( IsDeleted is null ) or ( IsDeleted = 0 ) 
	Order By Name
	
end
GO

----------------------------------------------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_ServerLines_GetAllExtInGS' ))
	Drop procedure dbo.A_ServerLines_GetAllExtInGS
GO

Create procedure dbo.A_ServerLines_GetAllExtInGS
as
begin

	Select e.Id, 
		case When ( ss.Name is null ) then SystemNumStr else SystemNumStr + ' (' + ss.Name + ')' end 
	From A_ServerExtLines e 
		Left join A_ServerStreams ss On e.StreamId = ss.Id 
	Order by SystemNum
	
end
GO

----------------------------------------------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Redirect_LoadRules' ))
	Drop procedure dbo.A_Redirect_LoadRules
GO

Create procedure dbo.A_Redirect_LoadRules
as
begin

	Select * 
	FROM A_Redirect r 
		inner join A_Users u on r.IdUser = u.Id 
	Order By IdUser, PriorityIndex
	
end
GO

----------------------------------------------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Redirect_LoadTimeTable' ))
	Drop procedure dbo.A_Redirect_LoadTimeTable
GO

Create procedure dbo.A_Redirect_LoadTimeTable
	@id uniqueidentifier
as
begin

	Select * 
	From A_Redirect_TimeTable 
	Where IdRedir = @id
	
end
GO

----------------------------------------------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Redirect_LoadAbonents' ))
	Drop procedure dbo.A_Redirect_LoadAbonents
GO

Create procedure dbo.A_Redirect_LoadAbonents
	@id uniqueidentifier
as
begin

	Select * 
	From A_Redirect_Abonents 
	Where IdRedir = @id
	
end
GO

----------------------------------------------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Users_LoadParams' ))
	Drop procedure dbo.A_Users_LoadParams
GO

Create procedure dbo.A_Users_LoadParams
as
begin

	Select IdUser, IsRedirect, IsCC, IsLunch, IsCCManual 
	From A_UserParams
	
end
GO

----------------------------------------------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_Task_GetListId' ))
	Drop procedure dbo.A_TaskManager_Task_GetListId
GO

Create procedure dbo.A_TaskManager_Task_GetListId
	@idtask uniqueidentifier
as
begin

	Select ListId 
	From A_TaskManager_Tasks 
	Where Id = @idtask
	
end
GO

----------------------------------------------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_Task_GetAllSimple' ))
	Drop procedure dbo.A_TaskManager_Task_GetAllSimple
GO

Create procedure dbo.A_TaskManager_Task_GetAllSimple
as
begin

	Select IdProject, Id, Name 
	From A_TaskManager_Tasks
	
end
GO

----------------------------------------------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_SmsTaskManager_Task_GetAllSimple' ))
	Drop procedure dbo.A_SmsTaskManager_Task_GetAllSimple
GO

Create procedure dbo.A_SmsTaskManager_Task_GetAllSimple
as
begin

	Select IdProject, Id, Name 
	From A_SmsTaskManager_Tasks
	
end
GO

----------------------------------------------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_List_GetAllSimple' ))
	Drop procedure dbo.A_TaskManager_List_GetAllSimple
GO

Create procedure dbo.A_TaskManager_List_GetAllSimple
as
begin

	Select ProjectId, Id, Name 
	From A_TaskManager_Lists
	
end
GO

----------------------------------------------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_CallCenter_CheckCustomOperatorIndexesExists' ))
	Drop procedure dbo.A_CallCenter_CheckCustomOperatorIndexesExists
GO

Create procedure dbo.A_CallCenter_CheckCustomOperatorIndexesExists
as
begin

	if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_CallCenter_Info_GetOperatorIndexes_Custom' ) ) 
		Select 1
	
end
GO

----------------------------------------------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_UserNotifyLog_GetByFilter' ))
	Drop procedure dbo.A_UserNotifyLog_GetByFilter
GO

Create procedure dbo.A_UserNotifyLog_GetByFilter
	@iduser uniqueidentifier,
	@dtstart datetime = NULL,
	@dtstop datetime = NULL,
	@tstart datetime = NULL,
	@tstop datetime = NULL,
	@searchtext nvarchar(1000) = NULL,
	@flagtypes int = NULL
as
begin

	Select *
	FROM A_User_NotifyLog 
	where ( IdUser = @iduser )
		and (( @dtstart is NULL ) or ( NotifyDateTime >= @dtstart ))
		and (( @dtstop is NULL ) or ( NotifyDateTime < @dtstop ))
		and (( @tstart is NULL ) or ( Cast(NotifyDateTime as float) - Floor(Cast(NotifyDateTime as float)) >= Cast(@tstart as float) - Floor(Cast(@tstart as float)) ))
		and (( @tstop is NULL ) or ( Cast(NotifyDateTime as float) - Floor(Cast(NotifyDateTime as float)) <= Cast(@tstop as float) - Floor(Cast(@tstop as float)) ))
		and (( @searchtext is NULL ) or ( TextInfo like '%' + @searchtext + '%' ))
		and (( @flagtypes is NULL ) or ( LogType & @flagtypes > 0 ))	
end
GO

----------------------------------------------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_DB_GetVersion' ))
	Drop procedure dbo.A_DB_GetVersion
GO

Create procedure dbo.A_DB_GetVersion
as
begin

	Select ValueDateTime 
	From A_Settings 
	Where [Name] like 'DBVersion'
	
end
GO