﻿use [oktell_settings]
GO

If object_id('dbo.H_createTableTrigger') is not null
	Drop Procedure dbo.H_createTableTrigger
GO

Create procedure dbo.H_CreateTableTrigger 
	@Table_name nVarchar(100),
	@where nVarchar(1000) = ''
As
begin

	Declare 
		@sql nVarchar(4000),
		@sql1 nVarchar(4000),
		@sql2 nVarchar(4000),
		@sql3 nVarchar(4000),
		@sql4 nVarchar(4000),
		@sql5 nVarchar(4000)
	Set @where = Coalesce(@where,'')
	Set @sql1 = 'If Exists (Select * From [dbo].sysobjects Where xtype = ''TR'' and name  = ''' + @Table_name + '_trg'')	
					Drop trigger dbo.' + @Table_name + '_trg'

	Exec (@sql1)
	---------- Отсеиваем таблицы, в которых есть поля типа ''image'',''ntext'',''text'
	If not exists ( Select 1 
					From syscolumns c
						Join systypes t on coalesce(c.xusertype,0) = coalesce(t.xusertype,0) 
							and coalesce(c.xtype,0) = coalesce(t.xtype,0) 
							and t.name IN ('image','ntext','text')
							and c.id = Object_id(@Table_name))
	Begin
	
		Set @sql = 'Create trigger dbo.' + @Table_name + '_trg ON [dbo].[' + @Table_name + '] 
			After insert, update, delete 
			As 
				Declare 
					@Action CHAR(1),
					@idTable int,
					@Tablename nVarchar(200),
					@id_column_name nVarchar(4000),
					@id_column_name_i nVarchar(4000),
					@id_column_name_d nVarchar(4000),
					@id_column_name_i_d nVarchar(4000),
					@h_id uniqueidentifier

				Set @Action = Case 
					when Exists(Select * From inserted) and Exists(Select * From deleted) Then ''U''
					when Exists(Select * From inserted) Then ''I''
					when Exists(Select * From deleted) Then ''D''
					Else null 
				End

				Declare 
					@a_name nVarchar(1000), 
					@tr_id Varchar(8000) , 
					@sql_queryT nVarchar(4000), 
					@sql_query nVarchar(4000),
					@side smallint
				
				If ((Select cast(replace(left(cast(SERVERPROPERTY(''productversion'') As Varchar),2),''.'','''') As INT)) > 8) begin
					Set @tr_id = (Select cast(transaction_id As Varchar(8000)) 
					From sys.dm_tran_current_transaction)
				end else begin 
					execute sp_getbindtoken @tr_id output
				end
				
				Set @side = 0

				Select top 1 
					@a_name = authorizeduser_name, 
					@sql_queryT = cast(sql_text as nVARCHAR(4000)), 
					@side = 1
				From [oktell].[dbo].H_Authorizeduserid_SPID 
				Where tr_id like @tr_id + ''%'' 
				Order by [getdate] DESC

				Set @a_name = coalesce(@a_name,SUSER_SNAME())
				Set nocount on;
				'
				
		Set @sql1 = '
				Create Table #temp 
				(
					EventType Varchar (30) collate database_default, 
					Parameters smallint, 
					EventInfo nVarchar(4000) collate database_default
				)
				
				Insert into #temp
					Exec sp_executesql N''DBCC inputbuffer (@@spid) WITH NO_INFOMSGS''
				
				Set @sql_query = (Select top 1 cast(EventInfo as nVARCHAR(4000)) From #temp)

				Select 
					@idTable = T.id, 
					@Tablename = OBJECT_NAME(T.id)
				From sysobjects P 
					Join sysobjects T ON P.parent_obj = T.id 
				Where P.id = @@procid 

				Select @id_column_name = Coalesce(@id_column_name + '', '','''') + QUOTENAME(column_name),
					@id_column_name_i = Coalesce(@id_column_name_i + '' + '''','''' + '','''') + '' cast(i.'' + QUOTENAME(column_name) + '' as nvarchar(3000))'',
					@id_column_name_d = Coalesce(@id_column_name_d + '' + '''','''' + '','''') + '' cast(d.'' + QUOTENAME(column_name) + '' as nvarchar(3000))'',
					@id_column_name_i_d = Coalesce(@id_column_name_i_d + '' AND '','''') + ''i.'' + QUOTENAME(column_name) + '' = d.'' + QUOTENAME(column_name)
				From information_schema.key_column_usage
				Where (objectproperty(object_id(constraint_name), ''IsPrimaryKey'') = 1)
					and (Table_name = @Tablename)

				Declare @Columns_Updated nVarchar(4000),
					@Columns_Updated_old nVarchar(4000),
					@Columns_Updated_new nVarchar(4000)
					
				If object_id(''tempdb..#inserted'') IS not NULL
					Drop Table #inserted
				
				Select * 
				Into #inserted 
				From inserted
				
				If object_id(''tempdb..#deleted'') IS not NULL
					Drop Table #deleted
					
				Select * 
				Into #deleted 
				From deleted
				
				If object_id(''tempdb..#res_Table'') IS not NULL
					Drop Table #res_Table
				create Table #res_Table 
				(
					id Varchar(500) collate database_default, 
					upd_cols nVarchar(2000) collate database_default, 
					old_val nVarchar(4000) collate database_default, 
					new_val nVarchar(4000) collate database_default
				)
				'	 

		Set @sql2 = '
				If (@Action = ''U'') begin
					Select 
						@Columns_Updated_old = Isnull(@Columns_Updated_old + '' + N''''; '''' + '', '''') + '' Case when i.['' + c.name + ''] != d.['' + c.name + ''] Then coalesce(cast(d.['' + c.name + ''] '' + Case when coalesce(c.collationid,0) > 0 Then N'' Collate Database_Default '' Else '''' End + '' As nVarchar(4000)),'''''''') Else ''''$'''' End '',
						@Columns_Updated = Isnull(@Columns_Updated + '' + N''''; '''' + '', '''') + '' Case when i.['' + c.name + ''] != d.['' + c.name + ''] Then '''''' + c.name + '''''' Else ''''$'''' End '',
						@Columns_Updated_new = Isnull(@Columns_Updated_new + '' + N''''; '''' + '', '''') + '' Case when i.['' + c.name + ''] != d.['' + c.name + ''] Then coalesce(cast(i.['' + c.name + ''] '' + Case when coalesce(c.collationid,0) > 0 Then N'' Collate Database_Default '' Else '''' End + '' As nVarchar(4000)),'''''''') Else ''''$'''' End ''
					From syscolumns c
						join systypes t ON coalesce(c.xusertype,0) = coalesce(t.xusertype,0)
							and coalesce(c.xtype,0) = coalesce(t.xtype,0)
							and t.name not IN (''image'',''ntext'',''text'')
					Where c.id = @idTable

					Set @Columns_Updated = coalesce(@Columns_Updated,N'''''''''''')
					Set @Columns_Updated_old = coalesce(@Columns_Updated_old,N'''''''''''')
					Set @Columns_Updated_new = coalesce(@Columns_Updated_new,N'''''''''''')

					Exec (N''Insert into #res_Table (id, upd_cols, old_val, new_val) 
								Select 
									cast('' + @id_column_name_i + N'' as Varchar(500)) id, 
									cast('' + @Columns_Updated + N'' as nVarchar(2000)) upd_cols, 
									cast('' + @Columns_Updated_old + N'' as nVarchar(4000)) old_val, 
									cast('' + @Columns_Updated_new + N'' as nVarchar(4000)) new_val 
								From #inserted i
									join #deleted d ON '' + @id_column_name_i_d )
				end
				'
				
		Set @sql3 = '
				If (@Action = ''I'') begin
					Select 
						@Columns_Updated_old = '''',
						@Columns_Updated = Isnull(@Columns_Updated + '' + N''''; '''' + '', '''') + '''''''' + c.name + '''''''',
						@Columns_Updated_new = Isnull(@Columns_Updated_new + '' + N''''; '''' + '', '''') + '' coalesce(cast(i.['' + c.name + ''] '' + Case when coalesce(c.collationid,0) > 0 Then N'' Collate Database_Default '' Else '''' End + '' As nVarchar(4000)),'''''''')''
					From syscolumns c
						join systypes t ON coalesce(c.xusertype,0) = coalesce(t.xusertype,0)
							and coalesce(c.xtype,0) = coalesce(t.xtype,0)
							and t.name not IN (''image'',''ntext'',''text'')
					Where c.id = @idTable

					Set @Columns_Updated = coalesce(@Columns_Updated,N'''''''''''')
					Set @Columns_Updated_old = coalesce(@Columns_Updated_old,N'''''''''''')
					Set @Columns_Updated_new = coalesce(@Columns_Updated_new,N'''''''''''')

					Exec (N''Insert into #res_Table (id, upd_cols, new_val)
								Select
									cast('' + @id_column_name_i + N'' as Varchar(500)) id,
									cast('' + @Columns_Updated + N'' as nVarchar(2000)) upd_cols,
									cast('' + @Columns_Updated_new + N'' as nVarchar(4000))
								From #inserted i'')
				end
				'

		Set @sql4 = '
				If (@Action = ''D'') begin
					Select 
						@Columns_Updated_old = Isnull(@Columns_Updated_old + '' + N''''; '''' + '', '''') + '' coalesce(cast(d.['' + c.name + ''] '' + Case when coalesce(c.collationid,0) > 0 Then N'' Collate Database_Default '' Else '''' End + '' As nVarchar(4000)),'''''''') '',
						@Columns_Updated = Isnull(@Columns_Updated + '' + N''''; '''' + '', '''') + '''''''' + c.name + ''''''''
					From syscolumns c
						join systypes t ON coalesce(c.xusertype,0) = coalesce(t.xusertype,0)
							and coalesce(c.xtype,0) = coalesce(t.xtype,0)
							and t.name not IN (''image'',''ntext'',''text'')
					Where c.id = @idTable

					Set @Columns_Updated = coalesce(@Columns_Updated,N'''''''''''')
					Set @Columns_Updated_old = coalesce(@Columns_Updated_old,N'''''''''''')

					Exec (N''Insert into #res_Table (id,upd_cols,old_val)
								Select
									cast('' + @id_column_name_d + N'' as Varchar(500)) id,
									cast('' + @Columns_Updated + N'' as nVarchar(2000)) upd_cols,
									cast('' + @Columns_Updated_old + N'' as nVarchar(4000)) old_val
								From #deleted d '' )
				End
				'
		
		Set @sql5 = '			
					Set @h_id = newid()
					
					Insert into [oktell].[dbo].H_HISTORY (
						[id]
						,[type]
						,Table_name
						,authorizeduser_name
						,columns_name
						,old_values
						,new_values
						,full_query_transactionT
						,full_query_transaction
						,tr_id
						,side
						,col_id
					)
						Select 
							@h_id
							,@Action
							,@Tablename
							,@a_name
							,replace(replace(upd_cols,''$; '',''''),''; $'','''')
							,replace(replace(old_val,''$; '',''''),''; $'','''')
							,replace(replace(new_val,''$; '',''''),''; $'','''')
							,@sql_queryT
							,@sql_query
							,@tr_id
							,@side
							,id
						From #res_Table Where Coalesce(replace(replace(upd_cols,''$; '',''''),''; $'',''''),''$'') != ''$'' ' + @where + '
				'
				
		--Select @sql, @sql1, @sql2, @sql3, @sql4, @sql5
		
		Exec (@sql + @sql1 + @sql2 + @sql3 + @sql4 + @sql5)
	End
End
GO

Declare @Table_name nVARCHAR(500)

Declare db_cursor cursor for  
	Select c.name name
	From sysobjects c
	Where ([type] = 'U')
		and exists (Select 1 
					From INFORMATION_SCHEMA.KEY_COLUMN_USAGE sub_k
					Where (objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1)
						and (sub_k.Table_name = c.name))
		and not c.name in ( 'A_BigInt',
							'A_LangTexts',
							'A_LineReactors',
							'A_Policy_Objects',
							'A_Policy_ObjectTypes',
							'A_Policy_PrivilegeDefaults',
							'A_Policy_Privileges',
							'A_Policy_SubjectGroupCache',
							'A_Policy_SubjectPrivileges',
							'A_Policy_SubjectTypePriority',							
							'A_Policy_SubjectTypes',
							'A_Stat_RecordDirectories',
							'A_Streams',
							'A_TaskManager_TaskAuto_List',
							'A_UserPhoto',
							'A_UserSettings' )
	Order by c.name
						
Open db_cursor   
Fetch next from db_cursor into @Table_name   

While (@@FETCH_STATUS = 0) begin
		Exec [dbo].H_CreateTableTrigger @Table_name		
		Fetch next from db_cursor into @Table_name   
end

Close db_cursor   
Deallocate db_cursor
GO

Exec [dbo].H_CreateTableTrigger 'A_Settings' , ' And [id] like ''us~%'' '
GO
