﻿if (not object_id ( 'dbo.A_ServerStartInfo' ) is null )
	Drop table dbo.A_ServerStartInfo
GO

if (object_id ( 'dbo.A_ServerStartInfo' ) is null ) begin
	Create table dbo.A_ServerStartInfo
	(
		[Id] int identity(1,1) primary key,
		[IdWorkplace] uniqueidentifier,
		[IdServer] nvarchar(200) collate database_default,
		[MachineName] nvarchar(200) collate database_default,
		[RegSerial] int,
		[LibVersion] nvarchar(50) collate database_default,
		[HalVersion] nvarchar(50) collate database_default,
		[SystemTick] int,
		[DTStart] datetime		
	)
end
GO

if (not object_id ( 'dbo.A_ServerStartInfo_Save' ) is null ) 
	Drop procedure dbo.A_ServerStartInfo_Save
GO

Create procedure dbo.A_ServerStartInfo_Save
	@wpid uniqueidentifier,
	@srvid nvarchar(200),
	@machinename nvarchar(200),
	@regserial int,
	@libvrs nvarchar(50),
	@halvrs nvarchar(50),
	@systemtick int,
	@dtnow datetime = NULL
as
begin

	if ( @dtnow is NULL )
		Set @dtnow = GetDate()
	
	Insert into dbo.A_ServerStartInfo (IdWorkplace, IdServer, MachineName, RegSerial, LibVersion, HalVersion, SystemTick, DTStart)
	Values ( @wpid, @srvid, @machinename, @regserial, @libvrs, @halvrs, @systemtick, @dtnow )
	
end
GO
