﻿

--if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_EmergencyDirections_Clear'))
--	Drop procedure dbo.A_EmergencyDirections_Clear
--GO

--if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_EmergencyDirections_Save'))
--	Drop procedure dbo.A_EmergencyDirections_Save
--GO

if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_EmergencyDirections_SaveMulti'))
	Drop procedure dbo.A_EmergencyDirections_SaveMulti
GO

Create procedure [dbo].A_EmergencyDirections_SaveMulti
	@xml ntext = NULL,
	@authorizeduserid uniqueidentifier = NULL
as
begin

	If object_id('dbo.H_Authorizeduserid_SPID_Save') is not NULL
		EXEC dbo.H_Authorizeduserid_SPID_Save @authorizeduserid
		
 
 	If object_id('tempdb..#tmp_xml') is not NULL
		Drop table #tmp_xml
	Create table #tmp_xml
	( 
		id uniqueidentifier,
		pos int
	)
			
	Declare @idoc1 int
	Exec sp_xml_preparedocument @idoc1 OUTPUT, @xml
	
	Insert into #tmp_xml (id, pos)
		Select id, pos
		From OpenXml (@idoc1, '/items/l', 2)	
		With ( 
			id varchar(50) '@id',
			pos int '@pos'
		)
		
	-- Удаляем те, что отсутствуют в параметре, но есть в таблице
	Delete 
	From dbo.A_EmergencyDirections
	Where not exists( Select 1
						From #tmp_xml x
						Where dbo.A_EmergencyDirections.ObjectId = x.id )
	
	-- Обновляем, те что есть в обоих местах
	Update w	
	Set w.OrderIdx = x.pos
	From dbo.A_EmergencyDirections w, #tmp_xml x
	Where (w.ObjectId = x.id)
		and (w.OrderIdx != x.pos)			
		
	-- Добавляем те, что есть в параметре, но нет в таблице
	Insert Into dbo.A_EmergencyDirections ( OrderIdx, ObjectId )
		Select x.pos, x.id
		From #tmp_xml x
		Where not exists ( Select 1
							From dbo.A_EmergencyDirections w
							Where (w.ObjectId = x.id))	
		
end
GO