﻿if Object_id('dbo.A_Cube_CC_EffortConnections_Update_From_TmpCube') Is not null
    Drop  procedure [dbo].[A_Cube_CC_EffortConnections_Update_From_TmpCube]
GO

CREATE procedure [dbo].[A_Cube_CC_EffortConnections_Update_From_TmpCube]
as
begin

    Declare @last_id int, @curr_id int, @last_delete_dt datetime
    Select @last_id = curr_id,
           @last_delete_dt = last_delete_dt
    From [oktell_cc_temp]..tmp_cube_track
       
    -- Записи в [oktell_cc_temp]..Tmp_A_Cube_CC_EffortConnections Держим только 1 день
    -- В полночь по серверному времени, произведется копирование очередной партии недостающих и чистка всех записей (в транзакции жесткой)
    If (DateDiff(dd, @last_delete_dt, GetDate()) > 0) begin
  
		-- В тразакции с удалением
        Begin Tran UpdAndTruncate
        
			Set Transaction Isolation Level Serializable
            
            Select @curr_id = max(id) 
            From [oktell_cc_temp]..Tmp_A_Cube_CC_EffortConnections 
            
            If (@curr_id > @last_id)
				Insert into [oktell_cc_temp]..A_Cube_CC_EffortConnections 
					Select IdProject,IdTask, IsOutput, IdEffort, IdOperator, IdInList, AbonentNumber, CallResult, CallResultInfo, DateTimeStart, DateStart, TimeStart, 
						DateTimeStop, IdConn, IdChain, IdAUser, IdBUser, IdExtLine, LenTime, LenQueue, IsBetweenOp, OpponentInfo, IsHandled, IsSuccess, 
						IsRecorded, IdRecDir, ALineNum, BLineNum, UserResult  
					From [oktell_cc_temp]..Tmp_A_Cube_CC_EffortConnections
					Where id BETWEEN @last_id + 1 AND @curr_id
            
			-- Можно было бы делать Delete с условием и без транзакции, но тогда чаще
			Truncate table [oktell_cc_temp]..Tmp_A_Cube_CC_EffortConnections
        
        Commit Tran UpdAndTruncate
        
        Update [oktell_cc_temp]..tmp_cube_track 
        Set last_delete_dt = GetDate(),
               last_id = 0, 
               curr_id = 0        
    
    end else begin
    
		-- Простое копирование
        Select @curr_id = Max(id) 
        From [oktell_cc_temp]..Tmp_A_Cube_CC_EffortConnections with (NOLOCK)
        
        If (@curr_id > @last_id)
			Insert [oktell_cc_temp]..A_Cube_CC_EffortConnections 
				Select IdProject, IdTask, IsOutput, IdEffort, IdOperator, IdInList, AbonentNumber, CallResult, CallResultInfo, DateTimeStart, DateStart, TimeStart, 
					DateTimeStop, IdConn, IdChain, IdAUser, IdBUser, IdExtLine, LenTime, LenQueue, IsBetweenOp, OpponentInfo, IsHandled, IsSuccess,
					IsRecorded, IdRecDir, ALineNum, BLineNum, UserResult  
				From [oktell_cc_temp]..Tmp_A_Cube_CC_EffortConnections with (NOLOCK)
				Where id BETWEEN @last_id + 1 AND @curr_id

        Update [oktell_cc_temp]..tmp_cube_track 
			Set last_id = @last_id + 1, 
				curr_id = @curr_id
    
    end
    
end
GO