﻿use oktell_settings
if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Scripts' ))
	if not exists (Select * FROM syscolumns where id=object_id ( 'dbo.A_Scripts' ) and name like 'modifieduserid' )
		Alter table dbo.A_Scripts Add modifieduserid uniqueidentifier
GO

use oktell
GO

if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Scripts' ))
	Drop view dbo.A_Scripts
GO

Create view A_Scripts
as 
	Select * FROM oktell_settings.dbo.A_Scripts
GO

---------------------------------------------
if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Scripts_Save' ))
	Drop procedure dbo.A_Scripts_Save
GO

Create procedure [dbo].[A_Scripts_Save]
	@id uniqueidentifier = NULL,
	@name nvarchar(1000),
	@type int,
	@idproject uniqueidentifier = NULL,
	@modifieduserid uniqueidentifier = NULL
as
begin
	
	if ( @id is NULL ) begin
	
		if not exists ( Select 1 
						From dbo.A_Scripts 
						Where ([type] = @type)
							and ([idproject] = @idproject)
							and ([name] = @name))							
			
			Insert into dbo.A_Scripts ( id, name, type, idproject, modifieduserid )
			Values ( NewID(), @name, @type, @idproject, @modifieduserid )
		
	end	else if exists ( Select 1 From dbo.A_Scripts Where id = @id ) begin
	
		Update dbo.A_Scripts
		Set [name] = @name,
			[type] = @type,
			[idproject] = @idproject,
			[modifieduserid] = @modifieduserid
		Where (id = @id)
			and ((name != @name)
				or (type != @type)
				or (idproject != @idproject)
				or (modifieduserid != @modifieduserid))
				
	end else begin
			
		Insert into dbo.A_Scripts ( id, name, type, idproject )
		Values ( @id, @name, @type, @idproject )
	
	end
	
end
GO

---------------------------------------------
if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Scripts_GetAll' ))
	Drop procedure dbo.A_Scripts_GetAll
GO

Create procedure [dbo].[A_Scripts_GetAll]
	@all bit = 0,
	@idproject uniqueidentifier = NULL	
as
begin
	
	if ( @all = 1 ) begin
		
		Select [id], [name], [type], [idproject], [modifieduserid]
		From dbo.A_Scripts
		
	end else begin
	
		Select [id], [name], [type], [idproject], [modifieduserid]
		From dbo.A_Scripts
		Where idproject = @idproject
	
	end
		
end
GO

-----------------------------------------------
if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Scripts_GetById' ))
	Drop procedure dbo.A_Scripts_GetById
GO

Create procedure [dbo].[A_Scripts_GetById]
	@id uniqueidentifier
as
begin
	
	Select [id], [name], [type], [idproject], [modifieduserid]
	From dbo.A_Scripts
	Where [id] = @id
	
end
GO