﻿
---------------------------------------------------------------
if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_DynamicConfig_Clear' ))
	Drop procedure dbo.A_DynamicConfig_Clear
GO

Create Procedure [dbo].[A_DynamicConfig_Clear] 
	@ext bit = 1,
	@int bit = 1,
	@currentserver nvarchar(200) = NULL
as
begin

	if ( @int = 1 ) begin

		Delete From A_ServerSipLines Where IsDynamicConfig = 1
	end

	if ( @ext = 1 ) begin
		
		Delete FROM A_ServerExtLines Where IsDynamicConfig = 1
		Delete FROM A_ServerGates Where IsDynamicConfig = 1
		Delete FROM A_ServerStreams Where IsDynamicConfig = 1
		Delete FROM A_CallRoutes Where IsDynamicConfig = 1	

		Delete From A_WorkPlaces Where IsDynamicConfig = 1

		Delete From A_CallRoutes_Lines Where not [idroute] in ( Select [ID] From A_CallRoutes )

	end
	
end
GO

-----------------------------
if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_DynamicConfig_Add_Phone' ))
	Drop procedure dbo.[A_DynamicConfig_Add_Phone]
GO

Create procedure [dbo].[A_DynamicConfig_Add_Phone]
	@phoneid uniqueidentifier,
	@type int = 5,
	@caption nvarchar(200) = '',	
	@linenumstr nvarchar(20) = '',
	@parentgroupid uniqueidentifier = '00000000-0000-0000-0000-000000000000',
	@defuserid uniqueidentifier = '00000000-0000-0000-0000-000000000000',
	@websockuserid uniqueidentifier = '00000000-0000-0000-0000-000000000000',
	@address nvarchar(100) = '',
	@sipuser nvarchar(100) = '',
	@siplogin nvarchar(100) = '',
	@sippass nvarchar(100) = '',
	@linecode nvarchar(200) = '',
	@citystraight bit = 0,
	@busymode int = 1,	
	@translit int = -1,
	@serverid uniqueidentifier = '00000000-0000-0000-0000-000000000000',
	@currentserver nvarchar(200) = NULL
as
Begin

	Declare @empty uniqueidentifier
	Set @empty = '00000000-0000-0000-0000-000000000000'

	-- Сервер определяем
	Declare @srvid uniqueidentifier
	Set @srvid = @serverid
	if ( @srvid = @empty )
		Select @srvid = [Id] 
		From A_WorkPlaces 
		Where ( hasfastengine = 1 ) and ( ParentID = @empty )
		
	-- В линии
	Insert into A_ServerSipLines ( Id, Type, ServerId, SystemNum, Enabled, Caption, CityStraight, ParentGroupId, DefaultUserId, Address, SipUser, SipLogin, SipPass, StreamId, BusyMode, LineCode, WebsockUserId, Translit, SystemNumStr, IsDynamicConfig )
	Values ( @phoneid, @type, @srvid, 0, 1, @caption, @citystraight, @parentgroupid, @defuserid, @address, @sipuser, @siplogin, @sippass, '00000000-0000-0000-0000-000000000000', @busymode, @linecode, @websockuserid, @translit, @linenumstr, 1)

	-- В рабочие места
	Declare @tableid uniqueidentifier
	Set @tableid = NEWID()
	
	Insert into A_WorkPlaces ( ID, Type, ParentID, Address, HasDatabase, HasExtLines, HasFastEngine, HasGSM, HasIntLines, HasLogic, name, LineID, SortIndex, IsDynamicConfig )
	Values ( @tableid, 0, @srvid, '', 0, 0, 0, 0, 0, 0, '', @empty, 9, 1 )

	Insert into A_WorkPlaces ( ID, Type, ParentID, Address, HasDatabase, HasExtLines, HasFastEngine, HasGSM, HasIntLines, HasLogic, name, LineID, SortIndex, IsDynamicConfig )
	Values ( @phoneid, 4, @tableid, @sipuser, 0, 0, 0, 0, 0, 0, '', @phoneid, 9, 1 )

	-- Гарантируем неповторяемость назначенных пользователей
	if (( @websockuserid is not null ) and ( @websockuserid != @empty ))
		Update A_ServerSipLines 
		Set WebSockUserId = @empty
		Where WebSockUserId != @empty
			And Id != @phoneid 
			And WebSockUserId = @websockuserid 

	if (( @defuserid is not null ) and ( @defuserid != @empty ))
		Update A_ServerSipLines 
		Set DefaultUserId = @empty
		Where DefaultUserId != @empty
			And Id != @phoneid 
			And DefaultUserId = @defuserid 
			
End
GO

-----------------------------
if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_DynamicConfig_Add_Gate' ))
	Drop procedure dbo.A_DynamicConfig_Add_Gate
GO

Create procedure [dbo].[A_DynamicConfig_Add_Gate]
	@gateid uniqueidentifier,
	@gatename nvarchar(200),
	@regtype int,
	@serverid uniqueidentifier = '00000000-0000-0000-0000-000000000000',
	@currentserver nvarchar(200) = NULL
as
Begin

	Declare @srvid uniqueidentifier
	Set @srvid = @serverid
	if ( @srvid = '00000000-0000-0000-0000-000000000000' )
		Select @srvid = [Id] 
		From A_WorkPlaces 
		Where ( hasfastengine = 1 ) and ( ParentID = '00000000-0000-0000-0000-000000000000' )	

	Insert into A_ServerGates ( Id, Name, IdServer, RegType, IsDynamicConfig )
	Values ( @gateid, @gatename, @srvid, @regtype, 1 )
	
End
GO

-----------------------------
if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_DynamicConfig_Add_Stream' ))
	Drop procedure dbo.A_DynamicConfig_Add_Stream
GO

Create procedure [dbo].[A_DynamicConfig_Add_Stream]
 	@streamid uniqueidentifier,
	@streamname nvarchar(200),
	@streamtype int,
	@streamaccount nvarchar(200) = '',
	@streampass nvarchar(200) = '',
	@streamdisplay nvarchar(200) = '',
	@defcallerid nvarchar(50) = '',
	@regtype int,
	@gateid uniqueidentifier,
	@dialmode int = 0,
	@serverid uniqueidentifier = '00000000-0000-0000-0000-000000000000',
	@currentserver nvarchar(200) = NULL
as
Begin

	Declare @srvid uniqueidentifier
	Set @srvid = @serverid
	if ( @srvid = '00000000-0000-0000-0000-000000000000' )
		Select @srvid = [Id] 
		From A_WorkPlaces 
		Where ( hasfastengine = 1 ) and ( ParentID = '00000000-0000-0000-0000-000000000000' )

	Insert into A_ServerStreams ( Id, Name, IdServer, Type, Account, RegType, GateId, DialMode, IsDynamicConfig, SipPass, SipDisplay, DefCallerId )
	Values ( @streamid, @streamname, @srvid, @streamtype, @streamaccount, @regtype, @gateid, @dialmode, 1, @streampass, @streamdisplay, @defcallerid )
	
End
GO
-----------------------------
if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_DynamicConfig_Add_ExtLine' ))
	Drop procedure dbo.A_DynamicConfig_Add_ExtLine
GO

Create procedure [dbo].[A_DynamicConfig_Add_ExtLine]
	@lineid uniqueidentifier,
	@type int = 7,
	@caption nvarchar(200) = '',	
	@linenum int = NULL,
	@linenumstr nvarchar(20) = NULL,
	@streamid uniqueidentifier,
	@linecode nvarchar(200) = '',
	@serverid uniqueidentifier = '00000000-0000-0000-0000-000000000000',
	@currentserver nvarchar(200) = NULL
as
Begin

	Declare @srvid uniqueidentifier
	Set @srvid = @serverid
	if ( @srvid = '00000000-0000-0000-0000-000000000000' )
		Select @srvid = [Id] 
		From A_WorkPlaces 
		Where ( hasfastengine = 1 ) and ( ParentID = '00000000-0000-0000-0000-000000000000' )

	if ( @linenum is NULL )
		Set @linenum = 0
	if ( @linenumstr is NULL )
		Set @linenumstr = cast ( @linenum as nvarchar (10))	

	Insert into A_ServerExtLines ( Id, ServerId, Caption, Type, DialType, CanSimpleOut, CanIP, CanAutoDial, Prefix, SystemNum, Enabled, CanMobile, ExtNumber, ConnectedPBX, StreamId, LineCode, IsDynamicConfig, SystemNumStr )
	Values ( @lineid, @srvid, @caption, @type, 0, 1, 1, 1, '', @linenum, 1, 1, '', 0, @streamid, @linecode, 1, @linenumstr )

End
GO

-----------------------------

if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_DynamicConfig_Add_CallRoute' ))
	Drop procedure dbo.A_DynamicConfig_Add_CallRoute
GO

Create procedure [dbo].[A_DynamicConfig_Add_CallRoute]
	@routeid uniqueidentifier,
	@routename nvarchar(200),
	@routedescription nvarchar(200) = '',
	@routecommand nvarchar(200) = '',
	@isexternal bit = 1,
	@routetype int = 0,
	@routecode nvarchar(200) = '',
	@currentserver nvarchar(200) = NULL
as
Begin

	Insert into A_CallRoutes ( Id, Name, Description, Command, IsExternal, Enabled, Type, Code, IsDynamicConfig )
	Values ( @routeid, @routename, @routedescription, @routecommand, @isexternal, 1, @routetype, @routecode, 1 )
	
End
GO

-----------------------------

if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_DynamicConfig_Remove_CallRoute' ))
	Drop procedure dbo.A_DynamicConfig_Remove_CallRoute
GO

Create procedure [dbo].[A_DynamicConfig_Remove_CallRoute]
	@routeid uniqueidentifier,
	@currentserver nvarchar(200) = NULL
as
Begin

	Delete From A_CallRoutes 
	Where Id = @routeid

	Delete From A_CallRoutes_Lines
	Where IdRoute = @routeid
	
End
GO

-----------------------------

if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_DynamicConfig_Remove_Gate' ))
	Drop procedure dbo.A_DynamicConfig_Remove_Gate
GO

Create procedure [dbo].[A_DynamicConfig_Remove_Gate]
	@gateid uniqueidentifier,
	@currentserver nvarchar(200) = NULL
as
Begin

	Delete From A_ServerGates
	Where Id = @gateid


	Declare @streams table ( [id] uniqueidentifier )
	Insert into @streams ( [id] )
	    Select [Id]
	    From A_ServerStreams
	    Where GateId = @gateid

	Delete From A_ServerStreams 
	Where GateId = @gateid


	Declare @lines table ( [id] uniqueidentifier )
	Insert into @lines ( [id] )
	    Select [Id]
	    From A_ServerExtLines
	    Where StreamId in ( Select [id] From @streams )

	Delete From A_ServerExtLines
	Where StreamId in ( Select [id] From @streams )


	Declare @routes table ( [id] uniqueidentifier )
	Insert into @routes ( [id] )
	    Select Distinct IdRoute
	    From A_CallRoutes_Lines
	    Where IdLine in ( Select [id] from @lines )

	Delete From A_CallRoutes_Lines
	Where IdLine in ( Select [id] from @lines )
	

	Delete From A_CallRoutes
	Where [Id] in ( Select [id] from @routes )
		And not [Id] in ( Select Distinct IdRoute From A_CallRoutes_Lines )
		
End
GO

-----------------------------

if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_DynamicConfig_Remove_Phone' ))
	Drop procedure dbo.A_DynamicConfig_Remove_Phone
GO

Create procedure [dbo].[A_DynamicConfig_Remove_Phone]
 	@phoneid uniqueidentifier,
 	@currentserver nvarchar(200) = NULL
as
Begin

	-- Из линий
	Delete From A_ServerSipLines
	Where Id = @phoneid

	-- Из рабочих мест
	Declare @tableid uniqueidentifier
	Select @tableid = ParentId
	From A_WorkPlaces
	Where Id = @phoneid
		And IsDynamicConfig = 1

	Delete From A_WorkPlaces
	Where Id = @tableid
		and IsDynamicConfig = 1

	Delete From A_WorkPlaces
	Where Id = @phoneid
		and IsDynamicConfig = 1
		
End
GO

-----------------------------

if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_DynamicConfig_Remove_Stream' ))
	Drop procedure dbo.A_DynamicConfig_Remove_Stream
GO

Create procedure [dbo].[A_DynamicConfig_Remove_Stream]
 	@streamid uniqueidentifier,
 	@currentserver nvarchar(200) = NULL
as
Begin
	Delete From A_ServerStreams 
	Where Id = @streamid


	Declare @lines table ( [id] uniqueidentifier )
	Insert into @lines ( [id] )
	    Select [Id]
	    From A_ServerExtLines
	    Where StreamId = @streamid

	Delete From A_ServerExtLines 
	Where StreamId = @streamid


	Declare @routes table ( [id] uniqueidentifier )
	Insert into @routes ( [id] )
	    Select Distinct IdRoute
	    From A_CallRoutes_Lines
	    Where IdLine in ( Select [id] from @lines )

	Delete From A_CallRoutes_Lines
	Where IdLine in ( Select [id] from @lines )
	

	Delete From A_CallRoutes
	Where [Id] in ( Select [id] from @routes )
		And not [Id] in ( Select Distinct IdRoute From A_CallRoutes_Lines )
End
GO

-----------------------------

if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_DynamicConfig_Modify_Gate' ))
	Drop procedure dbo.A_DynamicConfig_Modify_Gate
GO

Create procedure [dbo].[A_DynamicConfig_Modify_Gate]
	@gateid uniqueidentifier,
	@gatename nvarchar(200) = NULL,
	@currentserver nvarchar(200) = NULL
as
Begin
	if ( @gatename is not NULL )
	    Update A_ServerGates
	    Set Name = @gatename
	    Where Id = @gateid
End
GO

-----------------------------

if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_DynamicConfig_Modify_Phone' ))
	Drop procedure dbo.A_DynamicConfig_Modify_Phone
GO

Create procedure [dbo].[A_DynamicConfig_Modify_Phone]
	@phoneid uniqueidentifier,
	@parentgroupid uniqueidentifier = null,
	@defuserid uniqueidentifier = null,
	@websockuserid uniqueidentifier = null,
	@address nvarchar(100) = null,
	@sipuser nvarchar(100) = null,
	@siplogin nvarchar(100) = null,
	@sippass nvarchar(100) = null,
	@linecode nvarchar(200) = null,
	@citystraight bit = null,
	@busymode int = null,
	@translit int = null,
	@currentserver nvarchar(200) = NULL
as
Begin

	Declare @empty uniqueidentifier
	Set @empty = '00000000-0000-0000-0000-000000000000'

	-- Линии
	Update A_ServerSipLines
	Set 	
		ParentGroupId = IsNull ( @parentgroupid, ParentGroupId ),
		DefaultUserId = IsNull ( @defuserid, DefaultUserId ),
		WebSockUserId = IsNull ( @websockuserid, WebSockUserId ),
		Address = IsNull ( @address, Address ),
		SipUser = IsNull ( @sipuser, SipUser ),
		SipLogin = IsNull ( @siplogin, SipLogin ),
		SipPass = IsNull ( @sippass, SipPass ),
		LineCode = IsNull ( @linecode, LineCode ),
		BusyMode = IsNull ( @busymode, BusyMode ),
		CityStraight = IsNull ( @citystraight, CityStraight ),
		Translit = IsNull ( @translit, Translit )
	Where Id = @phoneid

	-- Рабочие места
	if ( @sipuser is not NULL )
		Update A_WorkPlaces
		Set Address = @sipuser
		Where id = @phoneid

	-- Гарантируем неповторяемость назначенных пользователей
	if (( @websockuserid is not null ) and ( @websockuserid != @empty ))
		Update A_ServerSipLines 
		Set WebSockUserId = @empty
		Where WebSockUserId != @empty
			And Id != @phoneid 
			And WebSockUserId = @websockuserid 

	if (( @defuserid is not null ) and ( @defuserid != @empty ))
		Update A_ServerSipLines 
		Set DefaultUserId = @empty
		Where DefaultUserId != @empty
			And Id != @phoneid 
			And DefaultUserId = @defuserid 
End
GO

-----------------------------

if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_DynamicConfig_Modify_Stream' ))
	Drop procedure dbo.A_DynamicConfig_Modify_Stream
GO

Create procedure [dbo].[A_DynamicConfig_Modify_Stream]
	@streamid uniqueidentifier,
	@streamname nvarchar(200) = NULL,
	@streamaccount nvarchar(200) = NULL,
	@streampass nvarchar(200) = NULL,
	@streamdisplay nvarchar(200) = NULL,
	@defcallerid nvarchar(50) = NULL,
	@currentserver nvarchar(200) = NULL
as
Begin	

	Update A_ServerStreams
	Set Name = case when (@streamname is not null) then @streamname else Name end,
		Account = case when (@streamname is not null) then @streamname else Name end,
		SipPass = case when (@streamname is not null) then @streamname else Name end,
		SipDisplay = case when (@streamname is not null) then @streamname else Name end,
		DefCallerId = case when (@streamname is not null) then @streamname else Name end
	Where (Id = @streamid)
		and ((( @streamname is not null ) and (@streamname != Name))
			or (( @streamaccount is not null ) and (@streamaccount != Account))
			or (( @streampass is not null ) and (@streampass != SipPass))
			or (( @streamdisplay is not null ) and (@streamdisplay != SipDisplay))
			or (( @defcallerid is not null ) and (@defcallerid != DefCallerId)))
End
GO

-----------------------------
-----------------------------
-----------------------------
if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_Line_GetFreeExtLineNumberSipFrom' ))
	Drop procedure dbo.[A_Line_GetFreeExtLineNumberSipFrom]
GO

Create procedure [dbo].[A_Line_GetFreeExtLineNumberSipFrom]
	@serverid uniqueidentifier = '00000000-0000-0000-0000-000000000000',
	@from int = 0,
	@currentserver nvarchar(200) = NULL
as
Begin

	Declare @number int
	Set @number = 13000

	Select @number = Cast ( Min ( SystemNumStr ) as int )
	From A_ServerExtLines 
	Where ( SystemNum / 1000 % 10 = 3 ) 
		And (( ServerId = @serverid ) or ( @serverid = '00000000-0000-0000-0000-000000000000' ))

	Declare @x table (num int)

	if ( @from > 1000 )
		Set @from = @from % 1000

	while ( @from < 999 ) begin

		set @from = @from + 1
		set @number = @number / 1000 * 1000 + @from

		Insert into @x (num)		
		Values ( @number )
	end

	Select Min ( num ) as EmptyNum
	From @x x
	Where not exists ( Select SystemNumStr From A_ServerExtLines where cast ( x.Num as nvarchar(10)) like SystemNumStr)

End
GO

----------------------------------------------------------------
----------------------------------------------------------------
----------------------------------------------------------------

if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_Registrar_DropSession' ))
	Drop procedure dbo.A_Registrar_DropSession
GO

Create procedure [dbo].[A_Registrar_DropSession]
	@sessionid int = -1,
	@account nvarchar(100) = '',
	@callid nvarchar(200) = '',
	@currentserver nvarchar(200) = NULL,
	@serverid nvarchar(200) = NULL /* для совместимости */
as
begin

	-- Удаляет сессию и контактные данные по указанной связке аккаунта, callid
	
	Declare @xsrv nvarchar(200)
	Set @xsrv = Coalesce (@currentserver, @serverid)
	
	Declare @id int		
	Set @id = @sessionid

	-- Если сессия явно не указана - по CallId найдем
	if ( @id <= 0 ) begin	
	    Select @id = Id 
	    From A_RegistrarSession
	    Where (CallId like @callid)
			and (Account like @account)
			and ((@xsrv is NULL) or (@xsrv = '') or (@xsrv = ServerId))
	end

	-- Сессию чистим
	Delete 
	From A_RegistrarSession
	Where Id = @id
	
	-- Контакты дочищаем по отсутствию сессий
	Delete
	From A_RegistrarContact
	Where not exists ( Select Id From A_RegistrarSession s Where s.Id = A_RegistrarContact.SessionId )

end
GO

-----------------------------
if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_Registrar_DropAccount' ))
	Drop procedure dbo.A_Registrar_DropAccount
GO

Create procedure [dbo].[A_Registrar_DropAccount]
	@account nvarchar(100) = '',
	@currentserver nvarchar(200) = NULL,
	@serverid nvarchar(200) = NULL /* для совместимости */
as
begin
	
	-- Удаляет все сессии и контакты, соответствующие указанному аккаунту
	
	Declare @xsrv nvarchar(200)
	Set @xsrv = Coalesce (@currentserver, @serverid)
	
	-- Сессии по аккаунту
	Delete 
	From A_RegistrarSession
	Where (Account = @account)
		and ((@xsrv is NULL) or (@xsrv = '') or (@xsrv = ServerId))
	
	-- Контакты дочищаем по отсутствию сессий
	Delete
	From A_RegistrarContact
	Where not exists ( Select Id From A_RegistrarSession s Where s.Id = A_RegistrarContact.SessionId )

end
GO

-----------------------------
if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_Registrar_GetData' ))
	Drop procedure dbo.A_Registrar_GetData
GO

Create procedure [dbo].[A_Registrar_GetData]
	@currentserver nvarchar(200) = NULL,
	@serverid nvarchar(200) = NULL /* для совместимости */
as
begin

	Declare @xsrv nvarchar(200)
	Set @xsrv = Coalesce (@currentserver, @serverid)

	-- Сначала лишние отфильтруем
	exec dbo.A_Registrar_FilterSessions

	-- Потом оставшиеся вернем
	Select CallId, Account, RecvAddr, IfaceAddr, OverNAT, VIA, CSeq, Nonce, NC, StartTimeX,
		DisplayName, URI, Type, Expires
	From A_RegistrarSession s
		Inner join A_RegistrarContact c on c.SessionId = s.Id
	Where (c.LocalTimeExpire > GetDate())
		and ((@xsrv is NULL) or (@xsrv = '') or (@xsrv = ServerId))
	Order by Account, CallId
	
end
GO

-----------------------------
if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_Registrar_UpdateSession' ))
	Drop procedure dbo.A_Registrar_UpdateSession
GO

Create procedure [dbo].[A_Registrar_UpdateSession]
	@sessionid int = -1,
	@callid nvarchar(200),
	@account nvarchar(100),
	@recvaddr nvarchar(50),
	@ifaceaddr nvarchar(50),
	@overnat nvarchar(10),
	@via nvarchar(200),
	@cseq nvarchar(10) = '0',
	@nonce nvarchar(100),
	@nc nvarchar(50),
	@starttimex nvarchar(50),
	@currentserver nvarchar(200) = NULL,
	@serverid nvarchar(200) = NULL /* для совместимости */
as
begin

	Declare @dtnow Datetime
	Set @dtnow = GetDate()
	
	Declare @xsrv nvarchar(200)
	Set @xsrv = Coalesce (@currentserver, @serverid)
	
	if ( @sessionid <= 0 ) begin

		Select @sessionid = Id
		From A_RegistrarSession
		Where (CallId = @callid)
			and (Account = @account)
			and ((@xsrv is NULL) or (@xsrv = '') or (@xsrv = ServerId))

		if ( @sessionid is NULL )
			Set @sessionid = -1
	end

	if ( @sessionid > 0 ) begin

	    Update A_RegistrarSession
	    Set RecvAddr = @recvaddr,
			IfaceAddr = @ifaceaddr,
			OverNat = @overnat,
			VIA = @via,
			CSeq = @cseq,
			Nonce = @nonce,
			NC = @nc,
			StartTimeX = @starttimex,
			LocalTimeUpdate = @dtnow,
			ServerId = @xsrv	
	    Where (Id = @sessionid)
			and ((@xsrv is NULL) or (@xsrv = '') or (@xsrv = ServerId))

		if ( @@rowcount > 0 ) begin
			Select cast ( @sessionid as int )
			return
		end
	
	end


	Insert into A_RegistrarSession ( CallId, Account, RecvAddr, IfaceAddr, OverNAT, VIA, CSeq, Nonce, NC, StartTimeX, LocalTimeCreate, LocalTimeUpdate, ServerId )
	Values ( @callid, @account, @recvaddr, @ifaceaddr, @overnat, @via, @cseq, @nonce, @nc, @starttimex, @dtnow, @dtnow, @xsrv )

	Select cast ( @@identity as int )
	
end
GO

-----------------------------
if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_Registrar_UpdateContact' ))
	Drop procedure dbo.A_Registrar_UpdateContact
GO

Create procedure [dbo].[A_Registrar_UpdateContact]
	@sessionid int,
	@displayname nvarchar(200) = '',
	@uri nvarchar(200),
	@type nvarchar(50),
	@expires int,
	@currentserver nvarchar(200) = NULL
as
begin

	Declare @xsrv nvarchar(200)
	Set @xsrv = @currentserver
		
	Declare @dtnow datetime, @localtimeexpire datetime
	Set @dtnow = GetDate()
	Set @localtimeexpire = DateAdd ( ss, @expires + 5, @dtnow )

	Update A_RegistrarContact
	Set Expires = @expires,
		LocalTimeExpire = @localtimeexpire
	Where SessionId = @sessionid
		And URI like @uri

	if ( @@rowcount = 0 ) begin

		Insert into A_RegistrarContact ( SessionId, DisplayName, URI, Type, Expires, LocalTimeExpire )
		Values ( @sessionid, @displayname, @uri, @type, @expires, @localtimeexpire )
	end
end
GO

--------------
if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Registrar_BanList' ))
	and not exists ( select * from syscolumns where name = 'serverid' and id = object_id ( 'dbo.A_Registrar_BanList' ))
		Alter table dbo.A_Registrar_BanList Add serverid nvarchar(200) 
GO

--------------

if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_Registrar_UpdateBanList' ))
	Drop procedure dbo.A_Registrar_UpdateBanList
GO

Create procedure [dbo].[A_Registrar_UpdateBanList]
	@ipaddress nvarchar(200) = NULL,
	@uaname nvarchar(200) = NULL,
	@reason int,
	@dtutc datetime,
	@dtutccancel datetime = NULL,
	@currentserver nvarchar(200) = NULL
as
begin
	
	Declare @xsrv nvarchar(200)	
	Set @xsrv = @currentserver
	
	if ( @reason = 0 ) begin
		
		Delete 
		From dbo.A_Registrar_BanList
		Where (((ipaddress = @ipaddress) and (not @ipaddress is null))
				or ((uaname = @uaname) and (not @uaname is null)))
			and ((@xsrv is NULL) or (@xsrv = '') or (@xsrv = serverid))
				
	end else begin
	
		Update dbo.A_Registrar_BanList
		Set reason = @reason,
			dtutc = @dtutc,
			dtutccancel = @dtutccancel
		Where (((ipaddress = @ipaddress) and (not @ipaddress is null))
				or ((uaname = @uaname) and (not @uaname is null)))
			and ((@xsrv is NULL) or (@xsrv = '') or (@xsrv = serverid))
		
		if ( @@rowcount = 0 )
			Insert into dbo.A_Registrar_BanList ( ipaddress, uaname, reason, dtutc, dtutccancel, serverid )
			Values ( @ipaddress, @uaname, @reason, @dtutc, @dtutccancel, @xsrv )
	
	end
	
end
GO

----------------------------------------------------------------
----------------------------------------------------------------
----------------------------------------------------------------

if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_StreamRegistration_Clear' ))
	Drop procedure dbo.A_StreamRegistration_Clear
GO

Create procedure [dbo].[A_StreamRegistration_Clear]
	@currentserver nvarchar(200) = NULL,
	@serverid nvarchar(200) = NULL /* для совместимости */
as
Begin
	
	Declare @xsrv nvarchar(200)
	Set @xsrv = Coalesce (@currentserver, @serverid)
	
	--Truncate table dbo.A_StreamRegistration
	Delete 
	From dbo.A_StreamRegistration
	Where (@xsrv is NULL) or (@xsrv = '') or (@xsrv = ServerId)

End
GO

-----------------------------
if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_StreamRegistration_Save' ))
	Drop procedure dbo.A_StreamRegistration_Save
GO

Create procedure [dbo].[A_StreamRegistration_Save]
	@streamid uniqueidentifier,
	@isphone bit,
	@isregistered bit,
	@dtnow datetime = null,
	@currentserver nvarchar(200) = NULL,
	@serverid nvarchar(200) = NULL /* для совместимости */
as
Begin
	
	if ( @dtnow is null )
		Set @dtnow = GetDate()
		
	Declare @xsrv nvarchar(200)
	Set @xsrv = Coalesce (@currentserver, @serverid)
	
	Update dbo.A_StreamRegistration
	Set IsRegistered = @isregistered,
		IsPhone = @isphone,
		OperationDT = @dtnow,
		ServerId = @xsrv
	Where (StreamId = @streamid)
		And ((@xsrv is NULL) or (@xsrv = '') or (@xsrv = ServerId))

	if ( @@rowcount = 0 ) begin

		Insert into dbo.A_StreamRegistration ( StreamId, IsPhone, IsRegistered, OperationDT, ServerId )
			Values ( @streamid, @isphone, @isregistered, @dtnow, @xsrv )		
	end

End
GO


----------------------------------------------------------------
----------------------------------------------------------------
----------------------------------------------------------------

if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_DB_Init' ))
	Drop procedure dbo.A_DB_Init
GO

Create procedure [dbo].[A_DB_Init]
	@currentserver nvarchar(200) = NULL
As
begin
		-- On Service Start after Update and Localization
	
		
		-- динамические объекты карты сети 
		exec dbo.A_DynamicConfig_Clear @currentserver = @currentserver

		-- Регистрации 
		exec dbo.A_StreamRegistration_Clear @currentserver = @currentserver
		
		-- Обновление кэша политики прав доступа к объектам
		exec dbo.A_Policy_SubjectGroupCache_CheckUpdate
		
		----------------------------------------
		-- Кастомные дела программистов DB
		exec dbo.A_DB_InitInternal @currentserver
		
		----------------------------------------
		-- Кастомные дела пользователей системы
		exec dbo.A_DB_InitCustom
end
GO

--------------------

if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_DB_InitOnStart' ))
	Drop procedure dbo.[A_DB_InitOnStart]
GO

Create procedure [dbo].[A_DB_InitOnStart]
	@currentserver nvarchar(200) = NULL
As
begin
		-- On PBXStatusServer start (2)

		-----------------------------------------------------
		-- Проставляем отвалившихся пользователей -----------
		-----------------------------------------------------
		
		Declare @lastpingtime datetime
		Set @lastpingtime = GetDate()
		select @lastpingtime = valueDateTime From A_Settings where [name] like 'PBXStatusServerPingTime'
		
		Declare @t1 table ( uid  uniqueidentifier ,  tm datetime )
		Insert into @t1
			Select UserId, Max ( TimeChange ) as TS FROM A_UserStateHistory Group By UserId
	

		Insert into A_UserStateHistory --with ( UpdLock )

		Select 	newid(), ush.UserId, 0, @lastpingtime, '', 0, 10104 --'Отвалился'
			From A_UserStateHistory ush inner join @t1 t on ush.UserId = t.uid and ush.TimeChange = t.tm
			Where ush.State != 0

		-----------------------------------------------------
		-- User in Task - проставляем в нуллы значения
		-----------------------------------------------------

		Update A_TaskManager_UserInTask with ( TabLock )
		Set	TimeStopPrior = IsNull ( TimeStopPrior, @lastpingtime ),
			TimeStopWaitCall = IsNull ( TimeStopWaitCall, @lastpingtime ),
			TimeStopBackCall = IsNull ( TimeStopBackCall, @lastpingtime ),
			TimeStopDialog = IsNull ( TimeStopDialog, @lastpingtime ),
			TimeStopPost = IsNull ( TimeStopPost, @lastpingtime )
		Where	( TimeStopPost is null ) or
			( TimeStopDialog is null ) or
			( TimeStopPrior is null ) or
			( TimeStopWaitCall is null ) or
			( TimeStopBackCall is null )

		-----------------------------------------------------
		-- избавление от нуллов в таблице статусов операторов коллцентра, если сервак вырубили
		-----------------------------------------------------

		Update A_CallCenter_UserStateHistory with ( TabLock )
		Set TimeLeave = @lastpingtime,
			LengthSec = Cast ( ( @lastpingtime - TimeEnter ) as float ) * 86400
		Where TimeLeave is NULL
		
		-----------------------------------------------------
		-- очищаем монополии
		-----------------------------------------------------
		
		Delete From A_Monopoly
		Delete From A_MonopolyForTaskChanging
		Delete From C_MonopolyForTaskChanging /*obsolete*/

		-----------------------------------------------------
		-- Пустые входящие задачи, необработанные - ексепшны и положенные трубы
		-----------------------------------------------------
		Delete 
		From A_TaskManager_Task_IncomingCalls
		Where ConnectionChainId = '00000000-0000-0000-0000-000000000000'

		-----------------------------------------------------
		-- неиспользуемые таблицы локальных списков
		-----------------------------------------------------

		Declare @llid int
		Declare @llname nvarchar ( 1000 )
		Declare @ltid uniqueidentifier
		Declare @ltids nvarchar ( 50 )
		Declare @sql nvarchar ( 500 )
		
		Declare tcursor Cursor For
			Select name, Id  
			From sysobjects 
			Where ([type] = 'U') 
				and (name like 'A_TaskManager_LocalList%')
		
		Open tcursor
		Fetch Next From tcursor 
					Into @llname, @llid

		While (@@FETCH_STATUS = 0) begin
		
			Set @llname = 'dbo.[' + @llname + ']'

			-- по названиям (id в названии и Id списка совпадают) (недостаточно в связи с переменой имен - может много быть таблиц с одним ид. N-1 надо удалить)	
			--set @ltids = SUBSTRING ( @llname, 30, 36 )
			--set @ltid = cast ( @ltids as uniqueidentifier )
			--If not exists ( Select Id from A_Taskmanager_Lists Where Id = @ltid )
	
			-- по явным ссылкам через поле JoinedTable в списках
			If not exists ( Select Id from A_TaskManager_Lists Where JoinedTable = @llname ) begin
				set @sql = ' DROP TABLE ' + @llname
				exec sp_executesql @stmt = @sql
			end

			Fetch Next From tcursor 
						Into @llname, @llid
		end

		Close tcursor
		Deallocate tcursor

		-----------------------------------------------------
		-----------------------------------------------------

		-- таблицы КЦ создать??
		--надо или нет обнулить счетчики текущих состояний для куба состояний?
		-- и саму таблицу тоже закрыть?
		-- вроде надо бы.. ничего не мешает, а от возможных глюков избавит..
		Exec dbo.A_CallCenter_Temp_OnLoad

		-----------------------------------------------------
		-----------------------------------------------------
		
		Declare @xsrv nvarchar(200)
		Set @xsrv = @currentserver
		
		Delete 
		From dbo.A_Registrar_BanList
		Where not (dtutccancel is null )
			and (DateDiff ( s, dtutc, GetUtcDate() ) > 180)
			and ((@xsrv is NULL) or (@xsrv = '') or (@xsrv = serverid))
			
		-----------------------------------------------------
		exec dbo.A_DB_UpdateOwnerUser
		
end
GO

-----------------------------
if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_DB_InitInternal' ))
	Drop procedure dbo.A_DB_InitInternal
GO

Create Procedure [dbo].[A_DB_InitInternal]
	@currentserver nvarchar(200) = NULL
as
begin

	-- On Service start. For internal usage
	
	Select 1
	
end
GO

