﻿
if (not object_id('dbo.A_Scripts_Save') is null)
	Drop procedure [dbo].[A_Scripts_Save]
GO

Create procedure [dbo].[A_Scripts_Save]
	@id uniqueidentifier = NULL,
	@name nvarchar(1000),
	@type int,
	@idproject uniqueidentifier = NULL,
	@modifieduserid uniqueidentifier = NULL
as
begin
	
	if ( @id is NULL ) begin
	
		if exists ( Select 1 
					From dbo.A_Scripts 
					Where ([type] = @type)
						and ([idproject] = @idproject)
						and ([name] = @name))
		begin
			
			Select @id = id
			From dbo.A_Scripts
			Where (([type] = @type)
					and ([idproject] = @idproject)
					and ([name] = @name))
					
			Update dbo.A_Scripts
			Set [modifieduserid] = @modifieduserid
			Where (([type] = @type)
					and ([idproject] = @idproject)
					and ([name] = @name))
				and ((modifieduserid is null) or (modifieduserid != @modifieduserid))
					
		end else begin					
			
			Set @id = NewID()
			
			Insert into dbo.A_Scripts ( id, name, type, idproject, modifieduserid )
			Values ( @id, @name, @type, @idproject, @modifieduserid )
			
		end
		
	end	else if exists ( Select 1 From dbo.A_Scripts Where id = @id ) begin
	
		Update dbo.A_Scripts
		Set [name] = @name,
			[type] = @type,
			[idproject] = @idproject,
			[modifieduserid] = @modifieduserid
		Where (id = @id)
			and ((name != @name)
				or (type != @type)
				or (idproject != @idproject)
				or ((modifieduserid is null) or (modifieduserid != @modifieduserid)))
				
	end else begin
		
		if exists ( Select 1 
					From dbo.A_Scripts 
					Where ([type] = @type)
						and ([idproject] = @idproject)
						and ([name] = @name))
			return 
			
		Insert into dbo.A_Scripts ( id, name, type, idproject )
		Values ( @id, @name, @type, @idproject )
	
	end
	
	
	/* В таблицах политики прав доступа изменяем имя и проставляем дефолтные привилегии
	*/
	if (@modifieduserid = '00000000-0000-0000-0000-000000000000') 
		Set @modifieduserid = NULL
		
	exec A_Policy_Objects_Save
		@idObject = @id,
		@type = 106,
		@name = @name,
		@idParentProject = @idproject,
		@actionUserId = @modifieduserid
	
end
GO