﻿If Not exists(select * from dbo.A_Settings Where [name] = N'LastTruncH_Authorizeduserid_SPIDDate' )
    Insert into dbo.A_Settings (   [name]  ,valuestr  ,valueint  ,valueDateTime  ,valueGuid  ,valuedouble)
        values (
               N'LastTruncH_Authorizeduserid_SPIDDate' -- name - nvarchar(200)
              ,Null -- valuestr - nvarchar(4000)
              ,Null   -- valueint - int
              ,'2015-01-01T00:00:00' -- valueDateTime - datetime
              ,Null -- valueGuid - uniqueidentifier
              ,Null  -- valuedouble - float
        )
Go

If Object_id('dbo.H_Authorizeduserid_SPID_Trunc') is not null   
    Drop procedure dbo.H_Authorizeduserid_SPID_Trunc
Go

Create procedure dbo.H_Authorizeduserid_SPID_Trunc 
AS
Begin
    Declare @lastTrunc datetime
    Select @lastTrunc = valueDateTime FROM dbo.A_Settings WHERE name = 'LastTruncH_Authorizeduserid_SPIDDate'

    If (datediff(dd,@lastTrunc,getdate()) > 0)
    Begin
        Begin Tran TrunTbl;
            Set Transaction Isolation Level Serializable;
            Truncate table dbo.H_Authorizeduserid_SPID;
        Commit Tran TrunTbl;
        
        Update dbo.A_Settings
            Set valueDateTime = getdate()
        Where name = 'LastTruncH_Authorizeduserid_SPIDDate';
    End
End
Go

If Object_id('dbo.A_Timer_MinuteProc') is not null   
    Drop procedure dbo.A_Timer_MinuteProc
Go

Create Procedure [dbo].[A_Timer_MinuteProc]
	@dtnow datetime = null
as
begin
	if ( @dtnow is null )	
		set @dtnow = GetDate()
	--------------------------------------------------------------------------------------------
	-- Обеспечивается однократность исполнения (при нескольких серверах к одной базе) 
	--------------------------------------------------------------------------------------------
   	Begin tran DbProcActive

		Declare @dtactive datetime
		Select @dtactive = valuedatetime from A_Settings where name like 'DB_procactive'
		if ( not @dtactive is null )
 		  if ( DateDiff ( mi, @dtactive, @dtnow ) < 10 ) begin
		    Rollback tran DbProcActive
		    return
		  end

		Update A_Settings Set valuedatetime = @dtnow where name like 'DB_procactive'
		if ( @@rowcount = 0 )
		  Insert into A_Settings (name, valuedatetime) Values ( 'DB_procactive', @dtnow )

   	Commit tran DbProcActive
	--------------------------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------

	-- Очистка неактуальных регистрационных сессий
	exec dbo.A_Registrar_FilterSessions
    
    -- Копируем данные из времянки в Cube_CC_EffortConnections
    exec dbo.A_Cube_CC_EffortConnections_Update_From_TmpCube
    
	--Время по которое производить расчет намеренно назад на 30 секунд отводим
	-- чтобы исключить возможность попадания в интервалы, когда отложенные сохранения в БД идут
	-- и когда одна таблица уже заполнена, а другая еще нет данными до текущего момента.
	-- ну и еще случаи частичного заполнения строки, когда данные вставляются в момент выборки
	Declare @tilldt DateTime
	Set @tilldt = DateAdd ( ss, -30, @dtnow )

	exec A_CallCenter_Temp_UpdateOperatorStates @tilldt
	
	-- Очистка неактуальных пользовательских сессий
	exec dbo.A_SessionStorage_FilterSessions @dtnow
	
	
	-- Обновление кэша политики прав доступа к объектам
	exec dbo.A_Policy_SubjectGroupCache_CheckUpdate
	
	-- Очистка пустых ссылок в таблицах политики прав доступа к объектам
	exec dbo.A_Policy_CheckFilter
	
	-- Очистка рабочей таблицы для триггерного логирования пользователя системы [oktell].[dbo].H_Authorizeduserid_SPID
    exec dbo.H_Authorizeduserid_SPID_Trunc
    
	-- Пользовательская процедура, которой можно пользоваться и изменять
	exec dbo.A_Timer_UserDefinedProc
	
	--------------------------------------------------------------------------------------------
	-- Обеспечивается однократность исполнения (при нескольких серверах к одной базе) 
	--------------------------------------------------------------------------------------------
	Delete From A_Settings where name like 'DB_procactive'
	--------------------------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------
end

GO