﻿if not (object_id('dbo.A_UserRoles_Rights_Save' ) is null)
	Drop procedure dbo.A_UserRoles_Rights_Save
GO

Create procedure [dbo].[A_UserRoles_Rights_Save]
 	@xml ntext,
	@authorizeduserid uniqueidentifier = NULL
As
begin

	If object_id('dbo.H_Authorizeduserid_SPID_Save') is not NULL
		EXEC dbo.H_Authorizeduserid_SPID_Save @authorizeduserid
		
	
	If object_id('tempdb..#tmp_xml') is not NULL
		Drop table #tmp_xml
	Create table #tmp_xml
	( 
		id uniqueidentifier, 
		knot nvarchar(100) collate database_default,
		name nvarchar(200) collate database_default,
		code nvarchar(100) collate database_default,
		isbasic bit
	)
			
	Declare @idoc1 int
	Exec sp_xml_preparedocument @idoc1 OUTPUT, @xml
	
	
	Insert into #tmp_xml (id, knot, name, code, isbasic)
		Select id, knot, name, code, isbasic
		From OpenXml (@idoc1, '/items/upd', 2)	
		With ( 
			id varchar(50) '@id',
			knot nvarchar(100) '@knot',
			name nvarchar(200) '@name',
			code nvarchar(100) '@code',
			isbasic bit '@b'			
		)
			
	If object_id('tempdb..#tmp_xml2') is not NULL
		Drop table #tmp_xml2
	Create table #tmp_xml2 ( id uniqueidentifier )
			
	Declare @idoc2 int
	Exec sp_xml_preparedocument @idoc2 OUTPUT, @xml
		
	Insert into #tmp_xml2 (id)
		Select id
		From OpenXml (@idoc2, '/items/rem', 2)	
		With ( id varchar(50) '@id' )
		
	-- Удаляем помеченные на удаление, остальные не трогаем
	Delete 
	From dbo.A_UserRoles_Rights
	Where exists ( Select 1	
					From #tmp_xml2 x
					Where dbo.A_UserRoles_Rights.Id = x.Id )
					
	-- Обновляем те что поменялись
	Update w
	Set	w.Knot = x.knot,
		w.Name = x.name,
		w.Code = x.code,
		w.IsBasic = x.isbasic
	From dbo.A_UserRoles_Rights w, #tmp_xml x
	Where (w.Id = x.Id)
		and ((w.Knot != x.knot)
			or (w.Name != x.name)
			or (w.Code != x.code)
			or (w.IsBasic != x.isbasic))

	-- Добавляем те, которых не было
	Insert Into dbo.A_UserRoles_Rights (Id, Knot, Name, Code, IsBasic) 
		Select id, knot, name, code, isbasic
		From #tmp_xml x
		Where not exists ( Select 1
							From dbo.A_UserRoles_Rights w
							Where w.Id = x.id )

end
GO