﻿use oktell_settings
if (not object_id('dbo.A_Plugins') is null) 
	if not exists (Select * From syscolumns where (id = object_id ( 'dbo.A_Plugins' )) 
										and (name like 'Ver'))
		Alter Table dbo.A_Plugins Add Ver nvarchar(50) not null Default ''
GO

use oktell
GO

if (not object_id('dbo.A_Plugins') is null) 
	Drop view dbo.A_Plugins
GO

Create view dbo.A_Plugins
as 
	Select *
	From oktell_settings.dbo.A_Plugins
GO


Update A_Plugins
Set Ver = '0.0.0'
Where Ver = ''
GO


if (not object_id('dbo.A_PlugIns_GetAll') is null) 
	Drop procedure dbo.A_PlugIns_GetAll
GO

Create procedure [dbo].[A_PlugIns_GetAll]
as
begin

	Select Id, Type, ObjectName, Name, Description, Path, LoadType, LoadMoment, Destination, LogMode, Ver
	From A_PlugIns
	Order by Name	
	
end
GO


if (not object_id('dbo.A_PlugIns_GetById') is null) 
	Drop procedure dbo.A_PlugIns_GetById
GO

Create procedure [dbo].A_PlugIns_GetById
	@id uniqueidentifier
as
begin

	Select Id, Type, ObjectName, Name, Description, Path, LoadType, LoadMoment, Destination, LogMode, Ver
	From A_PlugIns
	Where Id = @id	
	
end
GO


if (not object_id('dbo.A_PlugIns_Save') is null) 
	Drop procedure dbo.A_PlugIns_Save
GO

Create procedure [dbo].[A_PlugIns_Save]
	@id uniqueidentifier,
	@type int,
	@objectname nvarchar ( 400 ) = null,
	@name nvarchar ( 400 ),
	@description nvarchar ( 4000 ) = null,
	@path nvarchar ( 1000 ) = null,
	@loadtype int = 1,
	@loadmoment int = 0,
	@destination int = 1,
	@logmode int = 0,
	@version nvarchar(50) = '0.0.0',
	@authorizeduserid uniqueidentifier = NULL	
as
begin

	If object_id('dbo.H_Authorizeduserid_SPID_Save') is not NULL
		EXEC dbo.H_Authorizeduserid_SPID_Save @authorizeduserid
		
		
	Update A_PlugIns
	Set Type = @type,
		ObjectName = @objectname,
		Name = @name,
		Description = @description,
		Path = @path,
		LoadType = @loadtype,
		LoadMoment = @loadmoment,
		Destination = @destination,
		LogMode = @logmode,
		Ver = @version
	Where Id = @id

	if ( @@rowcount = 0 )
		Insert 
		Into A_PlugIns ( Id, Type, ObjectName, Name, Description, Path, LoadType, LoadMoment, Destination, LogMode, Ver )
		Values ( @id, @type, @objectname, @name, @description, @path, @loadtype, @loadmoment, @destination, @logmode, @version )
end
GO

